import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React from "react";
import ReactDOM from "react-dom";
import { v4 as uuid } from "uuid";
import AlertContext from "./AlertContext";
import TransitionWrapper from "./TransitionWrapper";
import { TopLeftBox, TopRightBox, BottomLeftBox, BottomRightBox } from "./StyledAlerts";
var PlacementWrapperDiv = {
  topLeft: TopLeftBox,
  topRight: TopRightBox,
  bottomLeft: BottomLeftBox,
  bottomRight: BottomRightBox
};

var AlertsProvider =
/*#__PURE__*/
function (_React$Component) {
  _inherits(AlertsProvider, _React$Component);

  function AlertsProvider(props) {
    var _this;

    _classCallCheck(this, AlertsProvider);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AlertsProvider).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "queue", []);

    _defineProperty(_assertThisInitialized(_this), "interval", void 0);

    _defineProperty(_assertThisInitialized(_this), "alertMountNode", void 0);

    _defineProperty(_assertThisInitialized(_this), "handleAdd", function (alertProps) {
      alertProps.placement = alertProps.placement || "bottomLeft"; // If the key is not provided, generate a new random key.

      alertProps.alertKey = alertProps.alertKey || uuid(); // Closing Alert will call remove method of this class to update state

      var curOnClose = alertProps.onClose;

      alertProps.onClose = function (key) {
        if (curOnClose) {
          curOnClose(key);
        }

        _this.handleRemove(alertProps.alertKey);
      };

      _this.queue.push(alertProps);

      _this.displayAlert();

      return alertProps.alertKey;
    });

    _defineProperty(_assertThisInitialized(_this), "handleRemove", function (key) {
      var index = _this.state.alerts.findIndex(function (i) {
        return i.alertKey === key;
      });

      if (index > -1) {
        _this.setState({
          alerts: [].concat(_toConsumableArray(_this.state.alerts.slice(0, index)), _toConsumableArray(_this.state.alerts.slice(index + 1)))
        });

        return true;
      }

      return false;
    });

    _this.state = {
      alerts: [],
      contextAPI: {
        addAlert: _this.handleAdd,
        removeAlert: _this.handleRemove
      }
    };
    _this.alertMountNode = document.createElement("div");

    _this.alertMountNode.classList.add("knitui-alerts-root");

    return _this;
  }

  _createClass(AlertsProvider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.body.appendChild(this.alertMountNode);
    }
  }, {
    key: "displayAlert",
    value: function displayAlert() {
      var _this2 = this;

      this.interval = this.interval ? this.interval : setInterval(function () {
        if (_this2.queue.length > 0) {
          _this2.setState(function (prevState) {
            return {
              alerts: [].concat(_toConsumableArray(prevState.alerts), [_this2.queue.shift()])
            };
          });
        } else {
          clearInterval(_this2.interval);
          _this2.interval = undefined;
        }
      }, 350);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearInterval(this.interval);
      document.body.removeChild(this.alertMountNode);
    }
  }, {
    key: "render",
    value: function render() {
      // alertsByPlace placement keys needs to be predefined, can not use each
      // alerts placement prop directly, because for transition of last element,
      // Wrapper Component is needed.
      var alertsByPlace = {
        topLeft: [],
        topRight: [],
        bottomLeft: [],
        bottomRight: []
      };
      this.state.alerts.forEach(function (alert) {
        var placement = alert.placement;
        alertsByPlace[placement] = [alert].concat(_toConsumableArray(alertsByPlace[placement]));
      });
      return React.createElement(AlertContext.Provider, {
        value: this.state.contextAPI
      }, this.props.children, ReactDOM.createPortal(React.createElement("div", {
        key: "knit-ui-alerts",
        className: "knit-ui-alerts"
      }, Object.entries(alertsByPlace).map(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            placement = _ref2[0],
            alertArr = _ref2[1];

        var Wrapper = PlacementWrapperDiv[placement];
        return React.createElement(Wrapper, {
          key: placement,
          "data-testid": "alerts-wrapper",
          className: "alerts-wrapper"
        }, React.createElement(TransitionWrapper, {
          alerts: alertArr
        }));
      })), this.alertMountNode));
    }
  }]);

  return AlertsProvider;
}(React.Component);

export default AlertsProvider;