import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useState, useEffect } from "react";
import { useTransition } from "react-spring";
import { TransitionDiv, AlertDiv } from "./StyledAlerts";
import Alert from "./Alert";

//Transition/Animation Using react-spring useTransition
var TransitionWrapper = function TransitionWrapper(props) {
  var config = function config(_item, state) {
    return {
      duration: 250,
      easing: function easing(t) {
        if (state === "leave") {
          return (Math.pow(t, 2) + Math.pow(t, 3)) / 2;
        } else {
          return Math.pow(t, 3); //Bezier Curve (0,0,0,1)
        }
      }
    };
  };

  var _useState = useState(props.alerts),
      _useState2 = _slicedToArray(_useState, 2),
      alerts = _useState2[0],
      setAlerts = _useState2[1];

  var _useState3 = useState(function () {
    return new WeakMap();
  }),
      _useState4 = _slicedToArray(_useState3, 1),
      alertRefMap = _useState4[0];

  useEffect(function () {
    setAlerts(props.alerts);
  }, [props.alerts]); // The type is defined `object` because react-spring typescript does not define
  // config as function with more than one argument, but it's js implementation does.
  // real interface is `UseTransition`

  var transitionProperties = {
    from: {
      height: 0,
      opacity: 0
    },
    enter: function enter(item) {
      return (
        /*#__PURE__*/
        function () {
          var _ref = _asyncToGenerator(
          /*#__PURE__*/
          _regeneratorRuntime.mark(function _callee(next) {
            return _regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return next({
                      height: alertRefMap.get(item),
                      opacity: 1
                    });

                  case 2:
                    return _context.abrupt("return", _context.sent);

                  case 3:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }));

          return function (_x) {
            return _ref.apply(this, arguments);
          };
        }()
      );
    },
    leave: {
      opacity: 0,
      height: 0
    },
    config: config
  };
  var transitionProps = useTransition(alerts, function (item) {
    return item.alertKey;
  }, transitionProperties);
  return React.createElement(React.Fragment, null, transitionProps.map(function (_ref2) {
    var key = _ref2.key,
        item = _ref2.item,
        _ref2$props = _ref2.props,
        life = _ref2$props.life,
        style = _objectWithoutProperties(_ref2$props, ["life"]);

    return React.createElement(TransitionDiv, {
      key: key,
      style: style
    }, React.createElement(AlertDiv, {
      ref: function ref(_ref3) {
        return _ref3 && alertRefMap.set(item, _ref3.offsetHeight);
      }
    }, React.createElement(Alert, item)));
  }));
};

export default TransitionWrapper;