import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React from "react";
import styled, { css } from "styled-components";
var TYPOGRAPHY_SIZE = 14;
var sharedStyles =
/*#__PURE__*/
css(["font-size:", ";line-height:", ";border-radius:", ";padding:0 3px 0 3px;display:flex;align-items:center;&:hover{background-color:", ";}cursor:", ";a,* a{text-decoration:underline;color:", ";}"], function (_ref) {
  var knitui = _ref.theme.knitui;
  return "".concat(knitui.typography[TYPOGRAPHY_SIZE].fontSize, "rem");
}, function (_ref2) {
  var knitui = _ref2.theme.knitui;
  return "".concat(knitui.typography[TYPOGRAPHY_SIZE].lineHeight, "rem");
}, function (_ref3) {
  var knitui = _ref3.theme.knitui;
  return knitui.inputBorderRadius;
}, function (_ref4) {
  var separator = _ref4.separator,
      knitui = _ref4.theme.knitui;
  return separator ? "" : knitui.chromaPalette.Neutral10;
}, function (props) {
  return props.separator ? "default" : "pointer";
}, function (_ref5) {
  var knitui = _ref5.theme.knitui;
  return knitui.shades.blue40;
});
export var StyledText =
/*#__PURE__*/
styled.span.withConfig({
  displayName: "BreadcrumbItem__StyledText",
  componentId: "b75bri-0"
})(["", " color:", ";"], sharedStyles, function (_ref6) {
  var knitui = _ref6.theme.knitui;
  return knitui.chromaPalette.Neutral50;
});
export var StyledActive =
/*#__PURE__*/
styled.span.withConfig({
  displayName: "BreadcrumbItem__StyledActive",
  componentId: "b75bri-1"
})(["", " color:", ""], sharedStyles, function (_ref7) {
  var knitui = _ref7.theme.knitui;
  return knitui.chromaPalette.Neutral90;
});

var BreadcrumbItem = function BreadcrumbItem(props) {
  var separator = props.separator,
      children = props.children,
      childStyle = props.childStyle,
      style = props.style,
      activeStyles = props.activeStyles,
      className = props.className,
      onClick = props.onClick,
      restProps = _objectWithoutProperties(props, ["separator", "children", "childStyle", "style", "activeStyles", "className", "onClick"]);

  var link;

  if ("activeElement" in props) {
    link = React.createElement(StyledActive, _extends({
      style: _objectSpread({}, childStyle, style, activeStyles),
      onClick: onClick,
      className: className
    }, restProps), children);
  } else {
    link = React.createElement(StyledText, _extends({
      style: _objectSpread({}, childStyle, style),
      onClick: onClick,
      className: className
    }, restProps), children);
  }

  return link;
};

export default BreadcrumbItem;