import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React from "react";
import styled from "styled-components";
import { ButtonBase } from "./components";

var getStyleForGhostButtons = function getStyleForGhostButtons(props) {
  var style = props.isAllGhost ? "\n        & ".concat(ButtonBase, ":not(:last-of-type){\n          border-right: 0px;\n        }\n        & ").concat(ButtonBase, ":hover,& ").concat(ButtonBase, ":focus{\n          border-right: 1px solid;\n        }\n        & ").concat(ButtonBase, ":hover+").concat(ButtonBase, ":focus{\n          margin-left: -1px;\n        }\n        & ").concat(ButtonBase, ":focus {\n          box-shadow: 0 0 2px;\n          z-index: 1;\n        }\n        & ").concat(ButtonBase, ":hover+").concat(ButtonBase, ", & ").concat(ButtonBase, ":focus+").concat(ButtonBase, "{\n          border-left: 0px;\n        }\n      ") : "\n        & ".concat(ButtonBase, ":not(:last-of-type)::after {\n          content: \"\";\n          display: block;\n          width: 1px;\n        }\n      ");
  return style;
};

var StyledVerticalBar =
/*#__PURE__*/
styled.hr.withConfig({
  displayName: "ButtonGroup__StyledVerticalBar",
  componentId: "osp032-0"
})(["margin-left:-1px;border:none;border-left:1px solid rgba(255,255,255,0.2);z-index:1;"]);
var ButtonGroupWrapper =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "ButtonGroup__ButtonGroupWrapper",
  componentId: "osp032-1"
})(["display:inline-flex;& ", "{border-radius:0rem;}& ", ":first-of-type{border-top-left-radius:0.4rem;border-bottom-left-radius:0.4rem;}& ", ":last-of-type{border-top-right-radius:0.4rem;border-bottom-right-radius:0.4rem;}", ""], ButtonBase, ButtonBase, ButtonBase, function (props) {
  return getStyleForGhostButtons(props);
});

var ButtonGroup = function ButtonGroup(props) {
  var children = props.children,
      rest = _objectWithoutProperties(props, ["children"]);

  var childrenCount = React.Children.count(children);
  var countGhost = 0;
  React.Children.forEach(children, function (child, i) {
    if (child.props.ghost) countGhost += 1;
  });
  var isAllGhost = countGhost === childrenCount ? true : false;
  return React.createElement(ButtonGroupWrapper, _extends({
    isAllGhost: isAllGhost
  }, rest), React.Children.map(props.children, function (child, i) {
    return i == childrenCount - 1 ? child : React.createElement(React.Fragment, null, child, !isAllGhost ? React.createElement(StyledVerticalBar, null) : null);
  }));
};

export default ButtonGroup;