import _extends from "@babel/runtime/helpers/extends";
import _typeof from "@babel/runtime/helpers/typeof";
import _taggedTemplateLiteral from "@babel/runtime/helpers/taggedTemplateLiteral";

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  cursor: inherit;\n  display: inline-block;\n  height: ", ";\n  width: ", ";\n  & svg {\n   ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import React from "react";
import styled from "styled-components";
import * as Icons from "./Icons";
import { withProps } from "../../common/_utils";
var StyledIconWrapper = withProps()(styled.span)(_templateObject(), function (_ref) {
  var height = _ref.height;
  return height;
}, function (_ref2) {
  var width = _ref2.width;
  return width;
}, function (_ref3) {
  var customStyles = _ref3.customStyles;
  return customStyles;
});

var Icon = function Icon(props) {
  var type = props.type,
      size = props.size,
      fill = props.fill,
      _props$customStyles = props.customStyles,
      customStyles = _props$customStyles === void 0 ? "" : _props$customStyles;
  var width = "18px",
      height = "18px";

  if (typeof size === "string") {
    width = size;
    height = size;
  } else if (_typeof(size) === "object") {
    width = size.width;
    height = size.height;
  }

  var svgStyles = {
    width: width,
    height: height,
    fill: fill // If type is not provided, then "oCheckBoxOutlineBlank" is used as placeholder icon

  };
  var defaultType = "oCheckBoxOutlineBlank";
  var icon = type && Icons[type] ? Icons[type](svgStyles) : Icons[defaultType](svgStyles);
  return React.createElement(StyledIconWrapper, _extends({}, props, {
    height: height,
    width: width,
    customStyles: customStyles
  }), icon);
};

export default Icon;