import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React from "react";
import { StyledInput, StyledTextArea } from "./styledComponents";
var RenderInput = React.forwardRef(function (props, ref) {
  var placeholder = props.placeholder,
      value = props.value,
      onChange = props.onChange,
      state = props.state,
      label = props.label,
      _props$inputSize = props.inputSize,
      inputSize = _props$inputSize === void 0 ? "default" : _props$inputSize,
      _props$type = props.type,
      type = _props$type === void 0 ? "default" : _props$type,
      _props$textareaResize = props.textareaResize,
      textareaResize = _props$textareaResize === void 0 ? "both" : _props$textareaResize,
      notification = props.notification,
      className = props.className,
      style = props.style,
      addonAfter = props.addonAfter,
      addonBefore = props.addonBefore,
      disabled = props.disabled,
      rest = _objectWithoutProperties(props, ["placeholder", "value", "onChange", "state", "label", "inputSize", "type", "textareaResize", "notification", "className", "style", "addonAfter", "addonBefore", "disabled"]);

  var customProps = {
    inputSize: inputSize,
    state: state
  };

  var commonProps = _objectSpread({
    ref: ref,
    placeholder: placeholder,
    customProps: customProps,
    className: className,
    style: style,
    value: value,
    onChange: onChange,
    disabled: disabled
  }, rest);

  if (props.type === "textarea") {
    return React.createElement(StyledTextArea, _extends({}, commonProps, {
      textareaResize: textareaResize
    }));
  }

  return React.createElement(StyledInput, _extends({
    type: props.type === "password" ? "password" : props.type === "number" ? "number" : "text"
  }, commonProps));
});
export default RenderInput;