import styled, { css } from "styled-components";
import Icon from "../Icon";
import { getPadding, getInputBorder, getHeight, getFontSize, getLineHeight, getBackgroundColor, getBorderRadius, getColor, getBoxShadow, getSelectionBackground, getAddonPadding } from "./utils";
export var InputWrapper =
/*#__PURE__*/
styled.span.withConfig({
  displayName: "styledComponents__InputWrapper",
  componentId: "l6uaxb-0"
})(["position:relative;display:flex;align-items:center;outline:none;"]); // Common styles for <input> and <textarea>

var commonInputStyles = function commonInputStyles(props) {
  return css(["width:100%;position:relative;border-radius:", ";border:", ";padding:", ";box-sizing:border-box;background-color:", ";color:", ";font-size:", ";line-height:", ";transition:border 0.25s ease;&:hover{border:", ";}&:focus,&:active{outline:none;background-color:", ";border:", ";box-shadow:", ";}&:disabled{cursor:not-allowed;background-color:", ";border:", ";box-shadow:none;resize:none;}&::placeholder{color:", ";}&::selection{background-color:", ";}"], getBorderRadius(props), getInputBorder(props, "default"), getPadding(props), getBackgroundColor(props), getColor(props), "".concat(getFontSize(props), "rem"), "".concat(getLineHeight(props), "rem"), getInputBorder(props, "hover"), getBackgroundColor(props, "focus"), getInputBorder(props, "focus"), getBoxShadow(props, "active"), getBackgroundColor(props), getInputBorder(props, "default"), getColor(props, "placeholder"), getSelectionBackground(props));
};

export var StyledInput =
/*#__PURE__*/
styled.input.withConfig({
  displayName: "styledComponents__StyledInput",
  componentId: "l6uaxb-1"
})(["", " min-height:", ";&[type=\"number\"]::-webkit-inner-spin-button{min-height:", ";}"], commonInputStyles, function (props) {
  return getHeight(props);
}, function (props) {
  return getHeight(props);
});
export var StyledTextArea =
/*#__PURE__*/
styled.textarea.withConfig({
  displayName: "styledComponents__StyledTextArea",
  componentId: "l6uaxb-2"
})(["", " font-family:InterRegular,-apple-system,BlinkMacSystemFont,\"Segoe UI\",Roboto,Helvetica,Arial,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",\"Segoe UI Symbol\";resize:", ";"], commonInputStyles, function (props) {
  return props.textareaResize;
});
var AddonSpan =
/*#__PURE__*/
styled.span.withConfig({
  displayName: "styledComponents__AddonSpan",
  componentId: "l6uaxb-3"
})(["display:inline-block;width:100%;position:relative;"]);
export var AddonBeforeSpan =
/*#__PURE__*/
styled(AddonSpan).withConfig({
  displayName: "styledComponents__AddonBeforeSpan",
  componentId: "l6uaxb-4"
})(["& input{padding-left:", "rem;}"], function (props) {
  return getAddonPadding(props.iconSize);
});
export var AddonAfterSpan =
/*#__PURE__*/
styled(AddonSpan).withConfig({
  displayName: "styledComponents__AddonAfterSpan",
  componentId: "l6uaxb-5"
})(["& input{padding-right:", "rem;}"], function (props) {
  return getAddonPadding(props.iconSize);
});
export var AddonContainer =
/*#__PURE__*/
styled.span.withConfig({
  displayName: "styledComponents__AddonContainer",
  componentId: "l6uaxb-6"
})(["display:flex;position:absolute;top:50%;transform:translateY(-50%);"]);
var labelStyle =
/*#__PURE__*/
css(["display:block;font-size:1.2rem;line-height:1.8rem;"]);
export var StyledLabel =
/*#__PURE__*/
styled.label.withConfig({
  displayName: "styledComponents__StyledLabel",
  componentId: "l6uaxb-7"
})(["", " text-transform:uppercase;color:", ";"], labelStyle, function (props) {
  return getColor(props, "label");
});
export var NotificationContainer =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styledComponents__NotificationContainer",
  componentId: "l6uaxb-8"
})(["", " color:", ";"], labelStyle, function (props) {
  return getColor(props, "notification");
});
export var IconBackground =
/*#__PURE__*/
styled.span.withConfig({
  displayName: "styledComponents__IconBackground",
  componentId: "l6uaxb-9"
})(["display:inline-block;height:", ";width:", ";border-radius:50%;background-color:#e5e5e5;"], function (props) {
  return props.bgSize;
}, function (props) {
  return props.bgSize;
});
export var AddonIcon =
/*#__PURE__*/
styled(Icon).withConfig({
  displayName: "styledComponents__AddonIcon",
  componentId: "l6uaxb-10"
})(["", ""], function (props) {
  return props.pointer && "cursor: pointer";
});