import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React from "react";
import styled from "styled-components";
import { getFontColor, getBackgroundColor } from "./commonUtils";
var DEFAULT_COLOR_THEME = "neutral";

var getFontSize = function getFontSize(props) {
  var fontSize = props.customProps.fontSize,
      typography = props.theme.knitui.typography;
  return typography[fontSize].fontSize;
};

var geLineHeight = function geLineHeight(props) {
  var fontSize = props.customProps.fontSize,
      typography = props.theme.knitui.typography;
  return typography[fontSize].lineHeight;
};

var verticalPadding = "0rem";

var getHorizontalPadding = function getHorizontalPadding(props) {
  var expanded = props.customProps.expanded;
  return expanded ? "0.3rem" : "0rem";
};

var StyledDiv =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "InlineLabel__StyledDiv",
  componentId: "so3hud-0"
})(["display:inline-flex;align-items:center;padding:", ";background-color:", ";color:", ";font-size:", ";line-height:", ";box-sizing:border-box;"], function (props) {
  return "".concat(verticalPadding, " ").concat(getHorizontalPadding(props));
}, function (props) {
  return getBackgroundColor(props);
}, function (props) {
  return getFontColor(props);
}, function (props) {
  return "".concat(getFontSize(props), "rem");
}, function (props) {
  return "".concat(geLineHeight(props), "rem");
});

var InlineLabel = function InlineLabel(_ref) {
  var className = _ref.className,
      style = _ref.style,
      rest = _objectWithoutProperties(_ref, ["className", "style"]);

  var text = rest.text;
  var scProps = {
    className: className,
    style: style,
    customProps: rest
  };
  return React.createElement(StyledDiv, _extends({}, scProps, {
    className: className,
    style: style
  }), React.createElement("span", null, text));
};

InlineLabel.defaultProps = {
  expanded: false,
  fontSize: 12,
  colorPreset: DEFAULT_COLOR_THEME
};
export default InlineLabel;