import _extends from "@babel/runtime/helpers/extends";
import React from "react";
import { StyledLink } from "./Link.styles";

var Link = function Link(_ref) {
  var className = _ref.className,
      style = _ref.style,
      underline = _ref.underline,
      href = _ref.href,
      children = _ref.children,
      disabled = _ref.disabled,
      newTab = _ref.newTab;
  var newTabProps = {
    target: "_blank",
    rel: "noopener noreferrer"
  };
  return React.createElement(StyledLink, _extends({
    underline: underline,
    className: className,
    style: style
  }, !disabled && {
    href: href
  }, {
    disabled: disabled
  }, newTab && newTabProps), children);
};

Link.defaultProps = {
  underline: true,
  disabled: false,
  newTab: false
};
export default Link;