import React from "react";
import styled from "styled-components";
var VERTICAL_PADDING = 1.4;

var getLineHeight = function getLineHeight(props) {
  var knitui = props.theme.knitui;
  var typographySize = knitui.modalTitleTypographySize;
  return knitui.typography[typographySize].lineHeight;
};

var getMinHeight = function getMinHeight(props) {
  var lineHeight = getLineHeight(props);
  return lineHeight + 2 * VERTICAL_PADDING;
};

var Container =
/*#__PURE__*/
styled.div.attrs(function () {
  return {
    "data-testid": "knit-modal-header"
  };
}).withConfig({
  displayName: "Header__Container",
  componentId: "xc02s6-0"
})(["display:flex;padding:", ";border-radius:", ";background:", ";border-bottom:", ";min-height:", ";"], function (_ref) {
  var knitui = _ref.theme.knitui;
  return "".concat(knitui.modalHeaderPadding.vertical, "rem ").concat(knitui.modalHeaderPadding.horizontal, "rem");
}, function (_ref2) {
  var knitui = _ref2.theme.knitui;
  return "".concat(knitui.modalBorderRadius, " ").concat(knitui.modalBorderRadius, " 0rem 0rem");
}, function (_ref3) {
  var knitui = _ref3.theme.knitui,
      noFill = _ref3.customProps.noFill;
  return noFill ? "none" : knitui.chromaPalette.Beige10;
}, function (_ref4) {
  var noFill = _ref4.customProps.noFill,
      knitui = _ref4.theme.knitui;
  return noFill ? knitui.modalBorder : "none";
}, function (props) {
  return "".concat(getMinHeight(props), "rem");
});

var Header = function Header(props) {
  var children = props.children;
  var scProps = {
    customProps: props
  };
  return React.createElement(Container, scProps, children);
};

export default Header;