import React from "react";
import styled from "styled-components";

var getPadding = function getPadding(props) {
  var knitui = props.theme.knitui,
      padding = props.customProps.padding;
  return padding ? "".concat(padding.vertical, " ").concat(padding.horizontal) : "".concat(knitui.modalPadding.vertical, "rem ").concat(knitui.modalPadding.horizontal, "rem");
};

var StyledMain =
/*#__PURE__*/
styled.div.attrs(function () {
  return {
    "data-testid": "knit-modal-body"
  };
}).withConfig({
  displayName: "Main__StyledMain",
  componentId: "sc-18bo4wn-0"
})(["padding:", ";overflow:auto;flex:1 1 auto;"], function (props) {
  return getPadding(props);
});
var Main = React.forwardRef(function (props, ref) {
  var children = props.children,
      _props$customProps = props.customProps,
      customProps = _props$customProps === void 0 ? {} : _props$customProps;
  return React.createElement(StyledMain, {
    ref: ref,
    customProps: customProps
  }, children);
});
Main.defaultProps = {
  padding: {
    vertical: "2.8rem",
    horizontal: "2.1rem"
  }
};
export default Main;