import React from "react";
import { Header, ScrollWrapper } from "../components";
import { BaseLayout, VerticalLayoutContent } from "./styledComponents";
import { getChildrenWithTypes } from "../helpers";

var BaseModal = function BaseModal(_ref) {
  var maxContentHeight = _ref.maxContentHeight,
      minContentHeight = _ref.minContentHeight,
      padding = _ref.padding,
      children = _ref.children;
  var childrenArray = React.Children.toArray(children);
  var childrenToRender = getChildrenWithTypes(childrenArray);
  return React.createElement(BaseLayout, null, React.createElement(Header, null, childrenToRender["header"]), React.createElement(VerticalLayoutContent, {
    customProps: {
      maxContentHeight: maxContentHeight,
      minContentHeight: minContentHeight
    }
  }, React.createElement(ScrollWrapper, {
    padding: padding
  }, childrenToRender["body"], childrenToRender["footer"])));
};

export default BaseModal;