import React from "react";
import styled from "styled-components";
import { BaseLayout, VerticalLayoutContent } from "./styledComponents";
import { Header, ScrollWrapper } from "../components";
import { getChildrenWithTypes } from "../helpers";
var BottomSection =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "BottomPanel__BottomSection",
  componentId: "sc-1jy10vg-0"
})(["box-sizing:border-box;height:8.4rem;border-top:", ";"], function (_ref) {
  var knitui = _ref.theme.knitui;
  return knitui.modalBorder;
});

var BottomPanelModal = function BottomPanelModal(_ref2) {
  var maxContentHeight = _ref2.maxContentHeight,
      minContentHeight = _ref2.minContentHeight,
      padding = _ref2.padding,
      children = _ref2.children;
  var childrenArray = React.Children.toArray(children);
  var childrenToRender = getChildrenWithTypes(childrenArray);
  return React.createElement(BaseLayout, null, React.createElement(Header, null, childrenToRender["header"]), React.createElement(VerticalLayoutContent, {
    customProps: {
      maxContentHeight: maxContentHeight,
      minContentHeight: minContentHeight
    }
  }, React.createElement(ScrollWrapper, {
    padding: padding
  }, childrenToRender["body"], childrenToRender["footer"]), React.createElement(BottomSection, null, childrenToRender["panel"])));
};

export default BottomPanelModal;