import React from "react";
import { BaseLayout } from "./styledComponents";
import { getChildrenWithTypes } from "../helpers";
import { Layout, PanelSection, Content } from "./styledComponents";
import { Header, ScrollWrapper } from "../components";

var LeftPanelModal = function LeftPanelModal(_ref) {
  var maxContentHeight = _ref.maxContentHeight,
      minContentHeight = _ref.minContentHeight,
      children = _ref.children,
      padding = _ref.padding;
  var childrenArray = React.Children.toArray(children);
  var childrenToRender = getChildrenWithTypes(childrenArray);
  return React.createElement(BaseLayout, null, React.createElement(Header, null, childrenToRender["header"]), React.createElement(Layout, {
    customProps: {
      maxContentHeight: maxContentHeight,
      minContentHeight: minContentHeight
    }
  }, React.createElement(PanelSection, {
    customProps: {
      location: "left"
    }
  }, childrenToRender["panel"]), React.createElement(Content, null, React.createElement(ScrollWrapper, {
    padding: padding
  }, childrenToRender["body"], childrenToRender["footer"]))));
};

export default LeftPanelModal;