import React from "react";
import { BaseLayout } from "./styledComponents";
import { Layout, PanelSection, Content } from "./styledComponents";
import { Header, ScrollWrapper } from "../components";
import { getChildrenWithTypes } from "../helpers";

var RightPanelModal = function RightPanelModal(_ref) {
  var maxContentHeight = _ref.maxContentHeight,
      minContentHeight = _ref.minContentHeight,
      children = _ref.children;
  var childrenArray = React.Children.toArray(children);
  var childrenToRender = getChildrenWithTypes(childrenArray);
  return React.createElement(BaseLayout, null, React.createElement(Header, null, childrenToRender["header"]), React.createElement(Layout, {
    customProps: {
      maxContentHeight: maxContentHeight,
      minContentHeight: minContentHeight
    }
  }, React.createElement(Content, null, React.createElement(ScrollWrapper, null, childrenToRender["body"], childrenToRender["footer"])), React.createElement(PanelSection, {
    customProps: {
      location: "right"
    }
  }, childrenToRender["panel"])));
};

export default RightPanelModal;