import styled from "styled-components";

var getPanelBorder = function getPanelBorder(props) {
  var location = props.customProps.location,
      knitui = props.theme.knitui;

  if (location === "right") {
    return "border-left: ".concat(knitui.modalBorder, ";");
  } // Assume location to be "left" by default


  return "border-right: ".concat(knitui.modalBorder, ";");
};

export var BaseLayout =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styledComponents__BaseLayout",
  componentId: "tfsh1t-0"
})(["display:flex;flex-direction:column;height:100%;min-height:inherit;"]);
export var Layout =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styledComponents__Layout",
  componentId: "tfsh1t-1"
})(["display:flex;flex-direction:row;align-items:stretch;flex:1 1 auto;max-height:", ";min-height:", ";"], function (props) {
  return props.customProps.maxContentHeight;
}, function (props) {
  return props.customProps.minContentHeight;
}); // Applies to left and right panels only

export var PanelSection =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styledComponents__PanelSection",
  componentId: "tfsh1t-2"
})(["width:21rem;flex-shrink:0;", " overflow-y:auto;"], function (props) {
  return getPanelBorder(props);
});
export var Content =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styledComponents__Content",
  componentId: "tfsh1t-3"
})(["display:flex;flex-direction:column;flex-grow:1;overflow:auto;"]);
export var VerticalLayoutContent =
/*#__PURE__*/
styled(Content).withConfig({
  displayName: "styledComponents__VerticalLayoutContent",
  componentId: "tfsh1t-4"
})(["max-height:", ";min-height:", ";"], function (props) {
  return props.customProps.maxContentHeight;
}, function (props) {
  return props.customProps.minContentHeight;
});