import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { Component } from "react";
import styled from "styled-components";
import Dialog from "rc-dialog";
import Input from "../Input";
import "rc-dialog/assets/index.css";
var StyledDialog =
/*#__PURE__*/
styled(Dialog).withConfig({
  displayName: "OmniSearch__StyledDialog",
  componentId: "sc-1jbk1wu-0"
})([".rc-dialog-body{padding:7px 0;}"]);
var InputWrapper =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "OmniSearch__InputWrapper",
  componentId: "sc-1jbk1wu-1"
})(["padding:0.7rem 1.4rem;"]);
var StyledInput =
/*#__PURE__*/
styled.input.withConfig({
  displayName: "OmniSearch__StyledInput",
  componentId: "sc-1jbk1wu-2"
})(["width:100%;border:none;font-size:1.6rem;margin-left:1rem;height:2rem;&::placeholder{color:", ";}"], function (props) {
  return getColor(props, "Neutral45");
});

var getColor = function getColor(props, color) {
  var knitui = props.theme.knitui;
  return knitui.chromaPalette[color];
};

var OmniSearch =
/*#__PURE__*/
function (_Component) {
  _inherits(OmniSearch, _Component);

  function OmniSearch(props) {
    var _this;

    _classCallCheck(this, OmniSearch);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(OmniSearch).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "searchRef", void 0);

    _defineProperty(_assertThisInitialized(_this), "focusSearch", function () {
      return _this.searchRef.current && _this.searchRef.current.focus();
    });

    _this.searchRef = React.createRef();
    return _this;
  }

  _createClass(OmniSearch, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var visible = this.props.visible;

      if (visible && !prevProps.visible) {
        this.focusSearch();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          visible = _this$props.visible,
          onClose = _this$props.onClose,
          onChange = _this$props.onChange,
          _this$props$value = _this$props.value,
          value = _this$props$value === void 0 ? "" : _this$props$value,
          _this$props$dropdown = _this$props.dropdown,
          dropdown = _this$props$dropdown === void 0 ? null : _this$props$dropdown,
          _this$props$placehold = _this$props.placeholder,
          placeholder = _this$props$placehold === void 0 ? "Search for a report" : _this$props$placehold;
      return React.createElement(StyledDialog, {
        visible: visible,
        onClose: onClose,
        closable: false
      }, React.createElement(InputWrapper, null, React.createElement(Input, {
        type: "search",
        role: "search",
        autoFocus: true,
        inputSize: "large",
        value: value,
        onChange: onChange,
        onBlur: this.focusSearch,
        placeholder: placeholder,
        ref: this.searchRef
      })), dropdown);
    }
  }]);

  return OmniSearch;
}(Component);

export default OmniSearch;