import styled, { css } from "styled-components";
import { getThemeColor } from "../../../common/_utils";
import Icon from "../../Icon";
export var OptionWrapper =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "Optionstyles__OptionWrapper",
  componentId: "sc-18ji9y6-0"
})(["font-size:1.4rem;line-height:2rem;display:flex;align-items:center;justify-content:space-between;color:", ";padding:0.7rem 1.4rem;border:0.1rem solid transparent;cursor:default;overflow:hidden;background-color:", ";", ""], function (props) {
  return getThemeColor(props, "Neutral90");
}, function (props) {
  return getThemeColor(props, props.selected ? "Neutral10" : "Neutral0");
}, function (_ref) {
  var isDisabled = _ref.isDisabled;
  return !isDisabled ? css(["&:active{border:0.1rem solid ", ";box-shadow:0 0 0.2rem #0066ff;z-index:1;}&:hover{background-color:", ";}"], function (props) {
    return getThemeColor(props, "Azure80");
  }, function (props) {
    return getThemeColor(props, "Neutral10");
  }) : css(["cursor:not-allowed;opacity:0.6;&:active{pointer-events:none;}"]);
});
export var OptionDescription =
/*#__PURE__*/
styled.span.withConfig({
  displayName: "Optionstyles__OptionDescription",
  componentId: "sc-18ji9y6-1"
})(["font-size:1.2rem;line-height:1.8rem;color:", ";"], function (props) {
  return getThemeColor(props, "Neutral50");
});
export var VerticalWrapper =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "Optionstyles__VerticalWrapper",
  componentId: "sc-18ji9y6-2"
})(["display:flex;flex-direction:column;overflow:hidden;"]);
export var StyledOptionText =
/*#__PURE__*/
styled.span.withConfig({
  displayName: "Optionstyles__StyledOptionText",
  componentId: "sc-18ji9y6-3"
})(["white-space:nowrap;text-overflow:ellipsis;overflow:hidden;"]);
export var FlexWrapper =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "Optionstyles__FlexWrapper",
  componentId: "sc-18ji9y6-4"
})(["display:flex;align-items:center;overflow:", ";"], function (props) {
  return props.align === "right" ? 'initial' : 'hidden';
});
export var StyledDivider =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "Optionstyles__StyledDivider",
  componentId: "sc-18ji9y6-5"
})(["margin:0.7rem 0;background-color:", ";height:0.1rem;"], function (props) {
  return getThemeColor(props, "Neutral20");
});
export var StyledIcon =
/*#__PURE__*/
styled(Icon).withConfig({
  displayName: "Optionstyles__StyledIcon",
  componentId: "sc-18ji9y6-6"
})(["margin-right:", ";margin-left:", ";"], function (props) {
  return props.align === "right" ? 0 : "1.5rem";
}, function (props) {
  return props.align === "right" ? "1.5rem" : 0;
}); // Generic component wrapper which styles a component and adds appropriate styles based on the position

export var OptionItemWrapper = function OptionItemWrapper(component, customProps) {
  return styled(component).withConfig({
    displayName: "Optionstyles",
    componentId: "sc-18ji9y6-7"
  })(["margin-right:", ";margin-left:", ";&:first-child{margin-left:0;}align-self:", ";"], function (props) {
    return props.align === "right" ? 0 : "1.5rem";
  }, function (props) {
    return props.align === "right" ? "1.5rem" : 0;
  }, customProps && customProps.alignStart ? "flex-start" : "center");
};