import React from "react";
import styled, { keyframes } from "styled-components";
var shim =
/*#__PURE__*/
keyframes(["from{left:-110%;}to{left:110%;}"]);

function getHeight(height) {
  switch (height) {
    case "large":
      return 3.2;

    case "medium":
      return 2.8;

    default:
      return 2;
  }
}

var ShimmerContainer =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "Shimmer__ShimmerContainer",
  componentId: "sc-1yky23q-0"
})(["width:100%;height:", ";background:", ";border-radius:4px;position:relative;overflow:hidden;"], function (_ref) {
  var customProps = _ref.customProps;
  return "".concat(getHeight(customProps.height), "rem");
}, function (_ref2) {
  var theme = _ref2.theme;
  return theme.knitui.chromaPalette.Neutral10;
});
var ShimmerElement =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "Shimmer__ShimmerElement",
  componentId: "sc-1yky23q-1"
})(["width:50%;max-width:35rem;background:rgba(204,204,204,0.3);height:100%;border-radius:4px;box-shadow:0px 14px 70px rgba(0,0,0,0.3);animation:", " 2000ms cubic-bezier(0.5,0,0,1) infinite;position:absolute;", ";"], shim, function (_ref3) {
  var animationOverrides = _ref3.animationOverrides;
  return animationOverrides;
});
export default function Shimmer(_ref4) {
  var _ref4$height = _ref4.height,
      height = _ref4$height === void 0 ? "small" : _ref4$height,
      className = _ref4.className,
      style = _ref4.style,
      _ref4$animationOverri = _ref4.animationOverrides,
      animationOverrides = _ref4$animationOverri === void 0 ? {} : _ref4$animationOverri;
  return React.createElement(ShimmerContainer, {
    className: className,
    style: style,
    customProps: {
      height: height
    }
  }, React.createElement(ShimmerElement, {
    animationOverrides: animationOverrides
  }));
}