function _templateObject() {
  var data = _taggedTemplateLiteral(["", ""]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import _taggedTemplateLiteral from "@babel/runtime/helpers/taggedTemplateLiteral";
import _styled from "styled-components";
import React from "react";
import { SortableElement, SortableHandle } from "react-sortable-hoc";
import { VerticalBar, DragIcon } from "./styles";
import { getTabContainerStyle } from "./utils";
export var TabDragElement = SortableHandle(function (_ref) {
  var children = _ref.children;
  return children;
});
export var TabItem = SortableElement(function (_ref2) {
  var value = _ref2.value,
      onChange = _ref2.onChange,
      activeKey = _ref2.activeKey,
      activeKeyIndex = _ref2.activeKeyIndex,
      itemIndex = _ref2.itemIndex,
      activeTabFlags = _ref2.activeTabFlags,
      itemRef = _ref2.itemRef,
      activeNxtRef = _ref2.activeNxtRef,
      activePrevRef = _ref2.activePrevRef,
      dragHandle = _ref2.dragHandle,
      DragHandleElement = _ref2.dragHandleElement,
      readOnly = _ref2.readOnly,
      customColor = _ref2.customColor;
  var props = value.props;
  var isActive = props.tabKey === activeKey;
  var handleElement = dragHandle && isActive && !readOnly ? React.createElement(TabDragElement, null, DragHandleElement ? React.createElement(DragHandleElement, null) : React.createElement(DragIcon, {
    type: "oDragIndicator",
    size: "16px"
  })) : null;
  var elem = React.cloneElement(value, {
    key: props.tabKey,
    active: isActive,
    dragHandle: dragHandle,
    role: "tab",
    "aria-controls": "tabpanel-id",
    customColor: customColor,
    children: [handleElement, props.tab],
    onClick: function onClick() {
      return !isActive && onChange(props.tabKey);
    }
  });
  var showVBar = itemIndex + 1 !== activeKeyIndex && !isActive;
  var styles = getTabContainerStyle(activeTabFlags, activeKeyIndex, itemIndex, itemRef);

  var getRef = function getRef() {
    if (activeKeyIndex === itemIndex) {
      return itemRef;
    } else if (activeKeyIndex + 1 === itemIndex) {
      return activeNxtRef;
    } else if (activeKeyIndex - 1 === itemIndex) {
      return activePrevRef;
    }

    return null;
  };

  return React.createElement(_StyledDiv, {
    ref: getRef(),
    id: isActive ? "knit-active-tab" : "",
    _css: styles
  }, elem, showVBar ? React.createElement(VerticalBar, {
    tabIndex: -1
  }) : null);
});

var _StyledDiv = _styled("div")(_templateObject(), function (p) {
  return p._css;
});