import React from "react";
import { SortableContainer } from "react-sortable-hoc";
import { TabItem } from "./TabItem";
import { OverflowContainer } from "./styles";
export var TabsList = SortableContainer(function (_ref) {
  var items = _ref.items,
      onChange = _ref.onChange,
      activeKey = _ref.activeKey,
      activeKeyIndex = _ref.activeKeyIndex,
      activeTabFlags = _ref.activeTabFlags,
      itemRef = _ref.itemRef,
      activeNxtRef = _ref.activeNxtRef,
      activePrevRef = _ref.activePrevRef,
      dragHandle = _ref.dragHandle,
      dragHandleElement = _ref.dragHandleElement,
      readOnly = _ref.readOnly,
      listRef = _ref.listRef,
      customColor = _ref.customColor;
  return React.createElement(OverflowContainer, {
    ref: listRef
  }, React.createElement("div", null), items.map(function (value, index) {
    return React.createElement(TabItem, {
      readOnly: readOnly,
      dragHandleElement: dragHandleElement,
      dragHandle: dragHandle,
      onChange: onChange,
      key: "tab-".concat(index),
      index: index,
      itemIndex: index,
      value: value,
      activeKey: activeKey,
      activeKeyIndex: activeKeyIndex,
      activeTabFlags: activeTabFlags,
      itemRef: itemRef,
      activeNxtRef: activeNxtRef,
      activePrevRef: activePrevRef,
      customColor: customColor
    });
  }));
});