import _taggedTemplateLiteral from "@babel/runtime/helpers/taggedTemplateLiteral";

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n.knitui-tabs-helper:not(#knit-active-tab) {\n  background: ", ";\n  \n  &:before {\n    content: \"\";\n    position: absolute;\n    left: 0;\n    top: 50%;\n    transform: translateY(-50%);\n    height: 1.4rem;\n    width: 1px;\n    background: ", ";\n  }\n}\n\n.knitui-tabs-helper {\n  white-space: nowrap;\n}\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import styled, { createGlobalStyle } from "styled-components";
import { Button, Icon } from "..";
import { getThemeColor, getColorOfLightness } from "../../common/_utils";
/* The tab being dragged is appended to the body, hence it's styles need to be at global scope*/

export var GlobalStyle =
/*#__PURE__*/
createGlobalStyle(_templateObject(), function (props) {
  return getThemeColor(props, props.customColor);
}, function (props) {
  return getThemeColor(props, "Neutral40");
});
export var ButtonWrapper =
/*#__PURE__*/
styled(Button).withConfig({
  displayName: "styles__ButtonWrapper",
  componentId: "sc-53bvbf-0"
})(["border-radius:4px 4px 0 0;:hover,:focus,:active{background:", ";}"], function (props) {
  return getColorOfLightness(props, props.bgColor, 90);
});
export var TabsWrapper =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styles__TabsWrapper",
  componentId: "sc-53bvbf-1"
})(["height:", ";width:100%;"], function (_ref) {
  var hideTabContent = _ref.hideTabContent;
  return hideTabContent ? "auto" : "100%";
});
export var TabsPanelWrapper =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styles__TabsPanelWrapper",
  componentId: "sc-53bvbf-2"
})(["display:flex;background:", ";"], function (props) {
  return getThemeColor(props, props.customColor);
});

var getActiveTabHeight = function getActiveTabHeight(props) {
  return "100%";
  /**
   * Idea was to assign height as much as active tab but during drag tab
   * height has extra 2px which causing recursive increase of OverflowWrapper's height.
   * Have to find work-around for this.
   */

  return props.activeTabRef.current ? "".concat(props.activeTabRef.current.getBoundingClientRect().height, "px") : "100%";
};

export var OverflowWrapper =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styles__OverflowWrapper",
  componentId: "sc-53bvbf-3"
})(["height:", ";overflow:hidden;position:relative;display:flex;"], function (props) {
  return getActiveTabHeight(props);
});
export var BlurElement =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styles__BlurElement",
  componentId: "sc-53bvbf-4"
})(["width:80px;height:100%;position:absolute;background:linear-gradient( to ", ",", "FF,", "00 );z-index:100;visibility:", ";pointer-events:none;"], function (props) {
  return props.dir === "left" ? "right" : "left";
}, function (props) {
  return getThemeColor(props, props.customColor);
}, function (props) {
  return getThemeColor(props, props.customColor);
}, function (props) {
  return props.visible ? "visible" : "hidden";
});
export var IconWrapper =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styles__IconWrapper",
  componentId: "sc-53bvbf-5"
})(["display:flex;justify-content:center;align-items:center;transition:visibility 250ms ease,width 150ms linear;visibility:", ";width:", ";cursor:pointer;z-index:100;:hover,:focus,:active{background:", ";}"], function (props) {
  return props.visible ? "visible" : "hidden";
}, function (props) {
  return props.visible ? "30px" : "0";
}, function (props) {
  return getColorOfLightness(props, props.customColor, 90);
});

var highlightBorderStyle = function highlightBorderStyle(props) {
  var customColor = props.customColor,
      active = props.active;
  var borderColor = active ? getColorOfLightness(props, customColor, 75) : "transparent";
  return "2px solid ".concat(borderColor);
};

var highlightBgColor = function highlightBgColor(props) {
  var customColor = props.customColor,
      active = props.active;
  var borderColor = active ? "#ffffff" : getColorOfLightness(props, customColor, 90);
  return borderColor;
};

export var TabPanel =
/*#__PURE__*/
styled.button.withConfig({
  displayName: "styles__TabPanel",
  componentId: "sc-53bvbf-6"
})(["display:flex;flex-wrap:nowrap;justify-content:center;align-items:center;word-wrap:none;background:", ";color:", ";border:2px solid transparent;border-top:", ";padding:4px 14px;border-radius:4px 4px 0px 0px;min-width:80px;line-height:20px;font-size:14px;cursor:", ";margin-right:", ";:hover{background:", ";}:active,:focus{z-index:101 !important;outline-color:", ";border-color:", " auto 1px;}"], function (props) {
  return props.active ? getThemeColor(props, "Neutral0") : "none";
}, function (props) {
  return props.active ? getThemeColor(props, "Neutral90") : getThemeColor(props, "Neutral50");
}, function (props) {
  return highlightBorderStyle(props);
}, function (props) {
  return props.dragHandle && props.active ? "auto" : "pointer";
}, function (props) {
  return props.active ? "0" : "1px";
}, function (props) {
  return highlightBgColor(props);
}, function (props) {
  return getThemeColor(props, "Azure80");
}, function (props) {
  return getThemeColor(props, "Azure80");
});
export var TabContentWrapper =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styles__TabContentWrapper",
  componentId: "sc-53bvbf-7"
})(["width:100%;"]);
export var OverflowContainer =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styles__OverflowContainer",
  componentId: "sc-53bvbf-8"
})(["display:flex;align-items:center;white-space:nowrap;width:100%;overflow-x:scroll;overflow-y:hidden;box-sizing:content-box;::-webkit-scrollbar{width:0px;background:transparent;display:none;}::-webkit-scrollbar-thumb{background:#ccc;}scrollbar-width:none;-ms-overflow-style:none;"]);
export var DragIcon =
/*#__PURE__*/
styled(Icon).withConfig({
  displayName: "styles__DragIcon",
  componentId: "sc-53bvbf-9"
})(["cursor:grab;& svg{fill:", ";}margin-right:0.4rem;& svg:hover,& svg:active,& svg:focus{fill:#000000;}"], function (props) {
  return getThemeColor(props, "Neutral45");
});
export var VerticalBar =
/*#__PURE__*/
styled.div.withConfig({
  displayName: "styles__VerticalBar",
  componentId: "sc-53bvbf-10"
})(["height:14px;width:0px;position:absolute;border-right:1px solid #cccccc;top:50%;right:0;transform:translateY(-50%);pointer-events:none;"]);