"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Azure100 = exports.Neutral90 = exports.Neutral80 = exports.Neutral70 = exports.Neutral60 = exports.Neutral50 = exports.Neutral45 = exports.Neutral40 = exports.Neutral30 = exports.Neutral20 = exports.Neutral10 = exports.Neutral05 = exports.Wood10 = exports.Coral10 = exports.Violet10 = exports.Sapphire10 = exports.Sun10 = exports.Fern10 = exports.Rose10 = exports.Beige10 = exports.Magenta80 = exports.Yellow80 = exports.Green80 = exports.Crimson80 = exports.Neutral0 = exports.LightBlue40 = exports.Azure80 = exports.Blue100 = void 0;

/* Primary Palette
---------------
The primary palette comprises bright and bold range of hues derived from Lapis lazuli. These should be used selectively to highlight the important actions and guide the eye.
*/
var Blue100 = {
  hsl: [216, 100, 20],
  hex: "#002966"
};
exports.Blue100 = Blue100;
var Azure80 = {
  hsl: [205, 85, 65],
  hex: "#5AB2F2"
};
exports.Azure80 = Azure80;
var LightBlue40 = {
  hsl: [203, 100, 95],
  hex: "#E5F5FF"
};
exports.LightBlue40 = LightBlue40;
var Neutral0 = {
  hsl: [0, 0, 100],
  hex: "#FFFFFF"
  /* Secondary Palette
  --------------------
  The secondary pallete comprises composed hues that compliment the primaries well. These provide a warmer tone to the product, and are deeply associated with the state and type of action, for instance, Crimson - danger/failure, Dark Lime - success, Pure Yellow - warning alerts, Moderate magenta - unsaved state.
  */

};
exports.Neutral0 = Neutral0;
var Crimson80 = {
  hsl: [0, 100, 30],
  hex: "#990000"
};
exports.Crimson80 = Crimson80;
var Green80 = {
  hsl: [118, 100, 20],
  hex: "#036600"
};
exports.Green80 = Green80;
var Yellow80 = {
  hsl: [47, 100, 50],
  hex: "#FFC700"
};
exports.Yellow80 = Yellow80;
var Magenta80 = {
  hsl: [288, 20, 35],
  hex: "#64476B"
  /* Tertiary Palette
  ---------------
  The tertiary palette comprises the washed-out hues that are used for highlights. It provides a softer experience and help in easily differentiating between bits.
  */

};
exports.Magenta80 = Magenta80;
var Beige10 = {
  hsl: [42, 38, 95],
  hex: "#F7F4ED"
};
exports.Beige10 = Beige10;
var Rose10 = {
  hsl: [0, 100, 95],
  hex: "#FFE3E3"
};
exports.Rose10 = Rose10;
var Fern10 = {
  hsl: [148, 33, 90],
  hex: "#DDEEE5"
};
exports.Fern10 = Fern10;
var Sun10 = {
  hsl: [40, 92, 90],
  hex: "#FDEDCE"
};
exports.Sun10 = Sun10;
var Sapphire10 = {
  hsl: [217, 80, 90],
  hex: "#D1E1FA"
};
exports.Sapphire10 = Sapphire10;
var Violet10 = {
  hsl: [274, 49, 90],
  hex: "#E7D9F2"
};
exports.Violet10 = Violet10;
var Coral10 = {
  hsl: [22, 80, 90],
  hex: "#FAE0D1"
};
exports.Coral10 = Coral10;
var Wood10 = {
  hsl: [33, 35, 85],
  hex: "#E6DACB"
  /* Neutral Palette
  ---------------
  The neutrals bring balance to the color palette, and used for actions that either don’t need direct attention or reduce focus from those already taking more than needed. Darker neutrals are used for shadows, borders, etc.
  */

};
exports.Wood10 = Wood10;
var Neutral05 = {
  hsl: [0, 0, 97],
  hex: "#F7F7F7"
};
exports.Neutral05 = Neutral05;
var Neutral10 = {
  hsl: [0, 0, 95],
  hex: "#F2F2F2"
};
exports.Neutral10 = Neutral10;
var Neutral20 = {
  hsl: [0, 0, 90],
  hex: "#E5E5E5"
};
exports.Neutral20 = Neutral20;
var Neutral30 = {
  hsl: [0, 0, 85],
  hex: "#D9D9D9"
};
exports.Neutral30 = Neutral30;
var Neutral40 = {
  hsl: [0, 0, 80],
  hex: "#CCCCCC"
};
exports.Neutral40 = Neutral40;
var Neutral45 = {
  hsl: [0, 0, 65],
  hex: "#A6A6A6"
};
exports.Neutral45 = Neutral45;
var Neutral50 = {
  hsl: [0, 0, 50],
  hex: "#808080"
};
exports.Neutral50 = Neutral50;
var Neutral60 = {
  hsl: [0, 0, 40],
  hex: "#666666"
};
exports.Neutral60 = Neutral60;
var Neutral70 = {
  hsl: [0, 0, 30],
  hex: "#4C4C4C"
};
exports.Neutral70 = Neutral70;
var Neutral80 = {
  hsl: [0, 0, 20],
  hex: "#333333"
};
exports.Neutral80 = Neutral80;
var Neutral90 = {
  hsl: [0, 0, 10],
  hex: "#1A1A1A"
};
exports.Neutral90 = Neutral90;
var Azure100 = {
  hsl: [205, 85, 40],
  hex: "#0F74BD"
};
exports.Azure100 = Azure100;