"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _uuid = require("uuid");

var _AlertContext = _interopRequireDefault(require("./AlertContext"));

var _TransitionWrapper = _interopRequireDefault(require("./TransitionWrapper"));

var _StyledAlerts = require("./StyledAlerts");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PlacementWrapperDiv = {
  topLeft: _StyledAlerts.TopLeftBox,
  topRight: _StyledAlerts.TopRightBox,
  bottomLeft: _StyledAlerts.BottomLeftBox,
  bottomRight: _StyledAlerts.BottomRightBox
};

var AlertsProvider =
/*#__PURE__*/
function (_React$Component) {
  _inherits(AlertsProvider, _React$Component);

  function AlertsProvider(props) {
    var _this;

    _classCallCheck(this, AlertsProvider);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AlertsProvider).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "queue", []);

    _defineProperty(_assertThisInitialized(_this), "interval", void 0);

    _defineProperty(_assertThisInitialized(_this), "alertMountNode", void 0);

    _defineProperty(_assertThisInitialized(_this), "handleAdd", function (alertProps) {
      alertProps.placement = alertProps.placement || "bottomLeft"; // If the key is not provided, generate a new random key.

      alertProps.alertKey = alertProps.alertKey || (0, _uuid.v4)(); // Closing Alert will call remove method of this class to update state

      var curOnClose = alertProps.onClose;

      alertProps.onClose = function (key) {
        if (curOnClose) {
          curOnClose(key);
        }

        _this.handleRemove(alertProps.alertKey);
      };

      _this.queue.push(alertProps);

      _this.displayAlert();

      return alertProps.alertKey;
    });

    _defineProperty(_assertThisInitialized(_this), "handleRemove", function (key) {
      var index = _this.state.alerts.findIndex(function (i) {
        return i.alertKey === key;
      });

      if (index > -1) {
        _this.setState({
          alerts: [].concat(_toConsumableArray(_this.state.alerts.slice(0, index)), _toConsumableArray(_this.state.alerts.slice(index + 1)))
        });

        return true;
      }

      return false;
    });

    _this.state = {
      alerts: [],
      contextAPI: {
        addAlert: _this.handleAdd,
        removeAlert: _this.handleRemove
      }
    };
    _this.alertMountNode = document.createElement("div");

    _this.alertMountNode.classList.add("knitui-alerts-root");

    return _this;
  }

  _createClass(AlertsProvider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.body.appendChild(this.alertMountNode);
    }
  }, {
    key: "displayAlert",
    value: function displayAlert() {
      var _this2 = this;

      this.interval = this.interval ? this.interval : setInterval(function () {
        if (_this2.queue.length > 0) {
          _this2.setState(function (prevState) {
            return {
              alerts: [].concat(_toConsumableArray(prevState.alerts), [_this2.queue.shift()])
            };
          });
        } else {
          clearInterval(_this2.interval);
          _this2.interval = undefined;
        }
      }, 350);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearInterval(this.interval);
      document.body.removeChild(this.alertMountNode);
    }
  }, {
    key: "render",
    value: function render() {
      // alertsByPlace placement keys needs to be predefined, can not use each
      // alerts placement prop directly, because for transition of last element,
      // Wrapper Component is needed.
      var alertsByPlace = {
        topLeft: [],
        topRight: [],
        bottomLeft: [],
        bottomRight: []
      };
      this.state.alerts.forEach(function (alert) {
        var placement = alert.placement;
        alertsByPlace[placement] = [alert].concat(_toConsumableArray(alertsByPlace[placement]));
      });
      return _react.default.createElement(_AlertContext.default.Provider, {
        value: this.state.contextAPI
      }, this.props.children, _reactDom.default.createPortal(_react.default.createElement("div", {
        key: "knit-ui-alerts",
        className: "knit-ui-alerts"
      }, Object.entries(alertsByPlace).map(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            placement = _ref2[0],
            alertArr = _ref2[1];

        var Wrapper = PlacementWrapperDiv[placement];
        return _react.default.createElement(Wrapper, {
          key: placement,
          "data-testid": "alerts-wrapper",
          className: "alerts-wrapper"
        }, _react.default.createElement(_TransitionWrapper.default, {
          alerts: alertArr
        }));
      })), this.alertMountNode));
    }
  }]);

  return AlertsProvider;
}(_react.default.Component);

var _default = AlertsProvider;
exports.default = _default;