"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactSpring = require("react-spring");

var _StyledAlerts = require("./StyledAlerts");

var _Alert = _interopRequireDefault(require("./Alert"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

//Transition/Animation Using react-spring useTransition
var TransitionWrapper = function TransitionWrapper(props) {
  var config = function config(_item, state) {
    return {
      duration: 250,
      easing: function easing(t) {
        if (state === "leave") {
          return (Math.pow(t, 2) + Math.pow(t, 3)) / 2;
        } else {
          return Math.pow(t, 3); //Bezier Curve (0,0,0,1)
        }
      }
    };
  };

  var _useState = (0, _react.useState)(props.alerts),
      _useState2 = _slicedToArray(_useState, 2),
      alerts = _useState2[0],
      setAlerts = _useState2[1];

  var _useState3 = (0, _react.useState)(function () {
    return new WeakMap();
  }),
      _useState4 = _slicedToArray(_useState3, 1),
      alertRefMap = _useState4[0];

  (0, _react.useEffect)(function () {
    setAlerts(props.alerts);
  }, [props.alerts]); // The type is defined `object` because react-spring typescript does not define
  // config as function with more than one argument, but it's js implementation does.
  // real interface is `UseTransition`

  var transitionProperties = {
    from: {
      height: 0,
      opacity: 0
    },
    enter: function enter(item) {
      return (
        /*#__PURE__*/
        function () {
          var _ref = _asyncToGenerator(
          /*#__PURE__*/
          regeneratorRuntime.mark(function _callee(next) {
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return next({
                      height: alertRefMap.get(item),
                      opacity: 1
                    });

                  case 2:
                    return _context.abrupt("return", _context.sent);

                  case 3:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }));

          return function (_x) {
            return _ref.apply(this, arguments);
          };
        }()
      );
    },
    leave: {
      opacity: 0,
      height: 0
    },
    config: config
  };
  var transitionProps = (0, _reactSpring.useTransition)(alerts, function (item) {
    return item.alertKey;
  }, transitionProperties);
  return _react.default.createElement(_react.default.Fragment, null, transitionProps.map(function (_ref2) {
    var key = _ref2.key,
        item = _ref2.item,
        _ref2$props = _ref2.props,
        life = _ref2$props.life,
        style = _objectWithoutProperties(_ref2$props, ["life"]);

    return _react.default.createElement(_StyledAlerts.TransitionDiv, {
      key: key,
      style: style
    }, _react.default.createElement(_StyledAlerts.AlertDiv, {
      ref: function ref(_ref3) {
        return _ref3 && alertRefMap.set(item, _ref3.offsetHeight);
      }
    }, _react.default.createElement(_Alert.default, item)));
  }));
};

var _default = TransitionWrapper;
exports.default = _default;