"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _AlertContext = _interopRequireDefault(require("./AlertContext"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function withAlerts(Component) {
  // Reference for ForwardRef - https://reactjs.org/docs/higher-order-components.html#refs-arent-passed-through
  var WrappedComponent = _react.default.forwardRef(function (props, ref) {
    return _react.default.createElement(_AlertContext.default.Consumer, null, function (context) {
      return _react.default.createElement(Component, _extends({}, props, {
        ref: ref,
        addAlert: context.addAlert,
        removeAlert: context.removeAlert
      }));
    });
  }); // To display name during debuging


  if (process.env.NODE_ENV !== "production") {
    WrappedComponent.displayName = "WithAlert(".concat(getDisplayName(Component), ")");
  }

  function getDisplayName(Component) {
    return Component.displayName || Component.name || "Component";
  } // Reference https://reactjs.org/docs/higher-order-components.html#static-methods-must-be-copied-over


  (0, _hoistNonReactStatics.default)(WrappedComponent, Component);
  return WrappedComponent;
}

var _default = withAlerts;
exports.default = _default;