"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _BreadcrumbItem = _interopRequireWildcard(require("./BreadcrumbItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var StyledParent =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Breadcrumb__StyledParent",
  componentId: "sc-1a81q2h-0"
})(["display:flex;max-width:", ";flex-wrap:wrap;width:fit-content;align-items:center;"], function (props) {
  return props.maxWidth || "initial";
});

var Breadcrumb = function Breadcrumb(props) {
  var className = props.className,
      rootStyle = props.rootStyle,
      maxWidth = props.maxWidth,
      children = props.children,
      _props$truncateTo = props.truncateTo,
      truncateTo = _props$truncateTo === void 0 ? Infinity : _props$truncateTo,
      separator = props.separator,
      activeStyles = props.activeStyles,
      childStyle = props.childStyle;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      showAll = _useState2[0],
      setShowAll = _useState2[1];

  var renderBreadcrumbs = function renderBreadcrumbs() {
    var updatedChildren = _react.default.Children.count(children) > 1 ? preprocessCrumbs(children, separator, truncateTo, setShowAll, showAll, childStyle) : children;

    var crumbs = _react.default.Children.map(updatedChildren, function (element, index) {
      if (!element) {
        return element;
      }

      return (0, _react.cloneElement)(element, {
        key: index,
        childStyle: childStyle,
        activeStyles: activeStyles
      });
    });

    return crumbs;
  };

  return _react.default.createElement(StyledParent, {
    className: className || "",
    maxWidth: maxWidth,
    style: rootStyle
  }, renderBreadcrumbs());
}; // Logic to insert separators among the list of children


var preprocessCrumbs = function preprocessCrumbs(crumbs, separator, truncateTo, setShowAll, showAll, childStyle) {
  // Container where we insert nodes and separators in appropriate places
  var updatedCrumbs = []; // A bool to check whether the ... is inserted or not

  var truncated = false; // Handle the range of truncateTo

  if (truncateTo < 1) {
    truncateTo = 1;
    console.warn("Prop 'truncateTo' has been set to 1 since it's the lowest possible value");
  }

  crumbs.forEach(function (crumb, index) {
    var shouldInsertCrumbs = index === 0 || index >= crumbs.length - truncateTo || showAll;

    if (shouldInsertCrumbs) {
      if (index !== crumbs.length - 1) {
        updatedCrumbs.push((0, _react.cloneElement)(crumb, {
          childStyle: childStyle
        }));
      } else {
        updatedCrumbs.push((0, _react.cloneElement)(crumb, {
          activeElement: true,
          childStyle: childStyle
        }));
      } // Insert nodes till last element


      if (index < crumbs.length - 1) {
        updatedCrumbs.push(_react.default.createElement(_BreadcrumbItem.StyledText, {
          style: childStyle,
          separator: true
        }, separator));
      }
    } else if (!truncated) {
      updatedCrumbs.push(_react.default.createElement(_BreadcrumbItem.StyledText, {
        style: childStyle,
        onClick: function onClick() {
          return setShowAll(true);
        }
      }, "..."));
      updatedCrumbs.push(_react.default.createElement(_BreadcrumbItem.StyledText, {
        style: childStyle,
        separator: true
      }, separator));
      truncated = true;
    }
  });
  return updatedCrumbs;
};

Breadcrumb.defaultProps = {
  separator: "/",
  truncateTo: Infinity
};
Breadcrumb.Item = _BreadcrumbItem.default;
var _default = Breadcrumb;
exports.default = _default;