"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.StyledActive = exports.StyledText = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var TYPOGRAPHY_SIZE = 14;
var sharedStyles =
/*#__PURE__*/
(0, _styledComponents.css)(["font-size:", ";line-height:", ";border-radius:", ";padding:0 3px 0 3px;display:flex;align-items:center;&:hover{background-color:", ";}cursor:", ";a,* a{text-decoration:underline;color:", ";}"], function (_ref) {
  var knitui = _ref.theme.knitui;
  return "".concat(knitui.typography[TYPOGRAPHY_SIZE].fontSize, "rem");
}, function (_ref2) {
  var knitui = _ref2.theme.knitui;
  return "".concat(knitui.typography[TYPOGRAPHY_SIZE].lineHeight, "rem");
}, function (_ref3) {
  var knitui = _ref3.theme.knitui;
  return knitui.inputBorderRadius;
}, function (_ref4) {
  var separator = _ref4.separator,
      knitui = _ref4.theme.knitui;
  return separator ? "" : knitui.chromaPalette.Neutral10;
}, function (props) {
  return props.separator ? "default" : "pointer";
}, function (_ref5) {
  var knitui = _ref5.theme.knitui;
  return knitui.shades.blue40;
});

var StyledText =
/*#__PURE__*/
_styledComponents.default.span.withConfig({
  displayName: "BreadcrumbItem__StyledText",
  componentId: "b75bri-0"
})(["", " color:", ";"], sharedStyles, function (_ref6) {
  var knitui = _ref6.theme.knitui;
  return knitui.chromaPalette.Neutral50;
});

exports.StyledText = StyledText;

var StyledActive =
/*#__PURE__*/
_styledComponents.default.span.withConfig({
  displayName: "BreadcrumbItem__StyledActive",
  componentId: "b75bri-1"
})(["", " color:", ""], sharedStyles, function (_ref7) {
  var knitui = _ref7.theme.knitui;
  return knitui.chromaPalette.Neutral90;
});

exports.StyledActive = StyledActive;

var BreadcrumbItem = function BreadcrumbItem(props) {
  var separator = props.separator,
      children = props.children,
      childStyle = props.childStyle,
      style = props.style,
      activeStyles = props.activeStyles,
      className = props.className,
      onClick = props.onClick,
      restProps = _objectWithoutProperties(props, ["separator", "children", "childStyle", "style", "activeStyles", "className", "onClick"]);

  var link;

  if ("activeElement" in props) {
    link = _react.default.createElement(StyledActive, _extends({
      style: _objectSpread({}, childStyle, style, activeStyles),
      onClick: onClick,
      className: className
    }, restProps), children);
  } else {
    link = _react.default.createElement(StyledText, _extends({
      style: _objectSpread({}, childStyle, style),
      onClick: onClick,
      className: className
    }, restProps), children);
  }

  return link;
};

var _default = BreadcrumbItem;
exports.default = _default;