"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _components = require("./components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var getStyleForGhostButtons = function getStyleForGhostButtons(props) {
  var style = props.isAllGhost ? "\n        & ".concat(_components.ButtonBase, ":not(:last-of-type){\n          border-right: 0px;\n        }\n        & ").concat(_components.ButtonBase, ":hover,& ").concat(_components.ButtonBase, ":focus{\n          border-right: 1px solid;\n        }\n        & ").concat(_components.ButtonBase, ":hover+").concat(_components.ButtonBase, ":focus{\n          margin-left: -1px;\n        }\n        & ").concat(_components.ButtonBase, ":focus {\n          box-shadow: 0 0 2px;\n          z-index: 1;\n        }\n        & ").concat(_components.ButtonBase, ":hover+").concat(_components.ButtonBase, ", & ").concat(_components.ButtonBase, ":focus+").concat(_components.ButtonBase, "{\n          border-left: 0px;\n        }\n      ") : "\n        & ".concat(_components.ButtonBase, ":not(:last-of-type)::after {\n          content: \"\";\n          display: block;\n          width: 1px;\n        }\n      ");
  return style;
};

var StyledVerticalBar =
/*#__PURE__*/
_styledComponents.default.hr.withConfig({
  displayName: "ButtonGroup__StyledVerticalBar",
  componentId: "osp032-0"
})(["margin-left:-1px;border:none;border-left:1px solid rgba(255,255,255,0.2);z-index:1;"]);

var ButtonGroupWrapper =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "ButtonGroup__ButtonGroupWrapper",
  componentId: "osp032-1"
})(["display:inline-flex;& ", "{border-radius:0rem;}& ", ":first-of-type{border-top-left-radius:0.4rem;border-bottom-left-radius:0.4rem;}& ", ":last-of-type{border-top-right-radius:0.4rem;border-bottom-right-radius:0.4rem;}", ""], _components.ButtonBase, _components.ButtonBase, _components.ButtonBase, function (props) {
  return getStyleForGhostButtons(props);
});

var ButtonGroup = function ButtonGroup(props) {
  var children = props.children,
      rest = _objectWithoutProperties(props, ["children"]);

  var childrenCount = _react.default.Children.count(children);

  var countGhost = 0;

  _react.default.Children.forEach(children, function (child, i) {
    if (child.props.ghost) countGhost += 1;
  });

  var isAllGhost = countGhost === childrenCount ? true : false;
  return _react.default.createElement(ButtonGroupWrapper, _extends({
    isAllGhost: isAllGhost
  }, rest), _react.default.Children.map(props.children, function (child, i) {
    return i == childrenCount - 1 ? child : _react.default.createElement(_react.default.Fragment, null, child, !isAllGhost ? _react.default.createElement(StyledVerticalBar, null) : null);
  }));
};

var _default = ButtonGroup;
exports.default = _default;