"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getBorderRadius = function getBorderRadius(position) {
  if (position === "right") return "0rem 0.3rem 0.3rem 0";
  return "0.3rem 0 0 0.3rem";
};

var getVerticalMargin = function getVerticalMargin(size) {
  switch (size) {
    case "small":
      return "0.1rem";

    case "large":
      return "0.7rem";

    default:
      return "0.4rem";
  }
};

var ButtonInset =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "ButtonInset",
  componentId: "sc-928lo5-0"
})(["display:inline-flex;background-color:", ";color:", ";font-size:", ";line-height:", ";border-radius:", ";margin-left:", ";margin-right:", ";span{margin:", " 0.7rem;line-height:2rem;}"], function (_ref) {
  var customProps = _ref.customProps;
  return customProps.backgroundColor;
}, function (_ref2) {
  var customProps = _ref2.customProps;
  return customProps.fontColor;
}, function (_ref3) {
  var customProps = _ref3.customProps;
  return customProps.fontSize;
}, function (_ref4) {
  var customProps = _ref4.customProps;
  return customProps.lineHeight;
}, function (_ref5) {
  var customProps = _ref5.customProps;
  return getBorderRadius(customProps.insetPosition);
}, function (_ref6) {
  var customProps = _ref6.customProps;
  return customProps.insetPosition === "right" ? "0.4rem" : 0;
}, function (_ref7) {
  var customProps = _ref7.customProps;
  return customProps.insetPosition === "right" ? 0 : "0.4rem";
}, function (_ref8) {
  var customProps = _ref8.customProps;
  return getVerticalMargin(customProps.size);
});

var _default = ButtonInset;
exports.default = _default;