"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EditorState = exports.TreeNode = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TreeNode =
/*#__PURE__*/
function () {
  function TreeNode(value) {
    _classCallCheck(this, TreeNode);

    _defineProperty(this, "value", void 0);

    _defineProperty(this, "children", void 0);

    this.value = value;
    this.children = [];
  }

  _createClass(TreeNode, [{
    key: "addChild",
    value: function addChild(node) {
      this.children.push(node);
    }
  }, {
    key: "setValue",
    value: function setValue(val) {
      this.value = val;
    }
  }, {
    key: "clearChildren",
    value: function clearChildren() {
      this.children = [];
    }
  }]);

  return TreeNode;
}();

exports.TreeNode = TreeNode;

var EditorState = function EditorState(_node) {
  var _this = this;

  _classCallCheck(this, EditorState);

  _defineProperty(this, "root", void 0);

  _defineProperty(this, "buildExpression", function () {
    var node = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.root;
    var str = "";
    if (node.value.type !== "fn") return node.value.data;
    node.children.forEach(function (child, idx) {
      str += _this.buildExpression(child);
      str += idx === node.children.length - 1 ? "" : ", ";
    });
    return "".concat(node.value.data.label, " (").concat(str, ")");
  });

  this.root = _node;
};

exports.EditorState = EditorState;