"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Dropdown = _interopRequireDefault(require("./Dropdown"));

var _DataStructure = require("./DataStructure");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Expression = function Expression(props) {
  var fname = props.fname,
      node = props.node,
      EditorData = props.EditorData,
      setExp = props.setExp,
      options = props.options,
      setValue = props.setValue,
      onChangeFn = props.onChangeFn,
      _props$expressionRoot = props.expressionRootClass,
      expressionRootClass = _props$expressionRoot === void 0 ? "" : _props$expressionRoot,
      _props$expressionInpu = props.expressionInputClass,
      expressionInputClass = _props$expressionInpu === void 0 ? "" : _props$expressionInpu,
      validationFn = props.validationFn;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      rootFocus = _useState2[0],
      setRootFocus = _useState2[1];

  var expressionRoot = (0, _react.useRef)(null); // find function metadata as per the given key.

  var fnData = options.find(function (f) {
    return f.key === fname.toLowerCase();
  });
  (0, _react.useEffect)(function () {
    // create nodes for all children of the given function
    var _ref = fnData,
        params = _ref.params;
    params.forEach(function () {
      var refNode = new _DataStructure.TreeNode({
        data: "",
        type: "string"
      });
      node.addChild(refNode);
    });
  }, []);

  var findNextNode = function findNextNode() {
    var initNode = expressionRoot.current.firstElementChild;
    if (initNode.dataset.type === "expression-root") return initNode;
    return initNode.firstElementChild;
  };

  var findPrevNode = function findPrevNode() {
    var initNode = expressionRoot.current;

    if (initNode.previousElementSibling) {
      initNode = initNode.previousElementSibling;

      while (initNode.lastElementChild && initNode.dataset.type === "expression-root") {
        initNode = initNode.lastElementChild;
      }

      initNode = initNode.firstElementChild;
    } else {
      if (initNode.parentElement.dataset.type === "expression-root") initNode = initNode.parentElement;
    }

    return initNode;
  };

  var handleKeyDown = function handleKeyDown(e) {
    e.stopPropagation(); // remove node when backspace is pressed and expression is in focus

    switch (e.keyCode) {
      case 8:
      case 46:
        if (rootFocus) {
          setExp(false);
          node.clearChildren();
          setValue("");
        }

        break;

      case 39:
        findNextNode().focus();
        break;

      case 37:
        findPrevNode().focus();
        break;

      default:
        return;
    }
  }; // Build the dom with dropdowns for the parameters of the function


  var PHDom = function PHDom() {
    var _ref2 = fnData,
        params = _ref2.params;
    return params.map(function (param, i) {
      return _react.default.createElement(_Dropdown.default, {
        EditorData: EditorData,
        key: i + param,
        onChangeFn: onChangeFn,
        options: options,
        expressionInputClass: expressionInputClass,
        expressionRootClass: expressionRootClass,
        node: node.children && node.children[i],
        validationFn: validationFn,
        initialFocus: i === 0,
        placeholder: param
      });
    });
  };

  if (fname) {
    return _react.default.createElement("span", {
      ref: expressionRoot,
      className: expressionRootClass,
      "data-type": "expression-root",
      onKeyDown: handleKeyDown,
      onFocus: function onFocus() {
        return setRootFocus(true);
      },
      onBlur: function onBlur() {
        return setRootFocus(false);
      },
      tabIndex: 0,
      style: {
        display: "flex"
      }
    }, fnData.label, "(", PHDom(), ")");
  }

  return null;
};

var _default = Expression;
exports.default = _default;