"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Dropdown = _interopRequireDefault(require("./Dropdown"));

var _DataStructure = require("./DataStructure");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _utils = require("../../common/_utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var stringRegex = /"([^\\"]|\\")*"/;
var expressionRootClass = "knit-ui_root-class";
var expressionInputClass = "knit-ui_input-class";

var validationFn = function validationFn(val) {
  // mock api request
  var res = !isNaN(val) || stringRegex.test(val); // console.log(res)

  return res;
};

var ExtractorWrapper =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Extractor__ExtractorWrapper",
  componentId: "g53ksf-0"
})(["width:100%;display:flex;overflow:auto;align-items:center;border:1px solid ", ";box-sizing:border-box;scrollbar-width:none;-ms-overflow-style:none;&::-webkit-scrollbar{display:none;}&:focus{box-shadow:0 0 0.2rem #0066ff;}border-radius:0.4rem;height:3.2rem;font-size:1.4rem;line-height:2rem;padding-left:1.4rem;input{border:0;outline:0;color:", ";height:2rem;border-radius:0.4rem;margin:0 0.6rem;background-color:inherit;padding:0 0.4rem;font-size:1.4rem;line-height:2rem;}input[data-value-type=\"dimension\"]{background-color:", ";}input[data-valid=\"false\"]{border-bottom:0.1rem dashed ", ";border-radius:0.2rem;box-sizing:border-box;}input[data-valid=\"true\"]{border-bottom:0;}[data-type=\"expression-root\"]{color:", ";box-sizing:border-box;display:flex;padding:0 0.4rem;&:focus{outline:1px dashed ", ";box-sizing:border-box;background:rgba(209,225,250,0.5);}&:not(:last-child):after{content:\",\";}}[data-type=\"expression-input-root\"]{display:flex;&:not(:last-child):after{content:\",\";}& > ul{margin-top:3rem;border:1px solid ", ";box-shadow:0px 2px 7px rgba(153,153,153,0.3);border-radius:4px;padding:1.4rem 0;width:28rem;position:absolute;li{font-size:1.4rem;line-height:2rem;display:flex;justify-content:space-between;padding:0.7rem 1.4rem;&:hover{background-color:", ";}span{&:nth-child(2){color:", ";font-style:italic;}&:first-child{color:", ";}}}}}"], function (props) {
  return (0, _utils.getThemeColor)(props, "Azure80");
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Neutral90");
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Sun10");
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Crimson80");
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Green80");
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Azure80");
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Neutral20");
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Neutral10");
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Neutral45");
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Green80");
});

var Extractor = function Extractor(props) {
  var onChangeFn = props.onChangeFn,
      options = props.options; // initialize root node of the expression

  var rootNode = new _DataStructure.TreeNode(null); // initialize the editor state with root node

  var EditorData = new _DataStructure.EditorState(rootNode);
  return _react.default.createElement(ExtractorWrapper, {
    "data-type": "knit-ui_extractor-root",
    tabIndex: 0
  }, _react.default.createElement(_Dropdown.default, {
    EditorData: EditorData,
    onChangeFn: onChangeFn,
    node: rootNode,
    expressionRootClass: expressionRootClass,
    expressionInputClass: expressionInputClass,
    options: options,
    placeholder: "Enter your expression",
    validationFn: validationFn
  }));
};

var _default = Extractor;
exports.default = _default;