"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var Icons = _interopRequireWildcard(require("./Icons"));

var _utils = require("../../common/_utils");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  cursor: inherit;\n  display: inline-block;\n  height: ", ";\n  width: ", ";\n  & svg {\n   ", ";\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var StyledIconWrapper = (0, _utils.withProps)()(_styledComponents.default.span)(_templateObject(), function (_ref) {
  var height = _ref.height;
  return height;
}, function (_ref2) {
  var width = _ref2.width;
  return width;
}, function (_ref3) {
  var customStyles = _ref3.customStyles;
  return customStyles;
});

var Icon = function Icon(props) {
  var type = props.type,
      size = props.size,
      fill = props.fill,
      _props$customStyles = props.customStyles,
      customStyles = _props$customStyles === void 0 ? "" : _props$customStyles;
  var width = "18px",
      height = "18px";

  if (typeof size === "string") {
    width = size;
    height = size;
  } else if (_typeof(size) === "object") {
    width = size.width;
    height = size.height;
  }

  var svgStyles = {
    width: width,
    height: height,
    fill: fill // If type is not provided, then "oCheckBoxOutlineBlank" is used as placeholder icon

  };
  var defaultType = "oCheckBoxOutlineBlank";
  var icon = type && Icons[type] ? Icons[type](svgStyles) : Icons[defaultType](svgStyles);
  return _react.default.createElement(StyledIconWrapper, _extends({}, props, {
    height: height,
    width: width,
    customStyles: customStyles
  }), icon);
};

var _default = Icon;
exports.default = _default;