"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = require("./styledComponents");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var RenderInput = _react.default.forwardRef(function (props, ref) {
  var placeholder = props.placeholder,
      value = props.value,
      onChange = props.onChange,
      state = props.state,
      label = props.label,
      _props$inputSize = props.inputSize,
      inputSize = _props$inputSize === void 0 ? "default" : _props$inputSize,
      _props$type = props.type,
      type = _props$type === void 0 ? "default" : _props$type,
      _props$textareaResize = props.textareaResize,
      textareaResize = _props$textareaResize === void 0 ? "both" : _props$textareaResize,
      notification = props.notification,
      className = props.className,
      style = props.style,
      addonAfter = props.addonAfter,
      addonBefore = props.addonBefore,
      disabled = props.disabled,
      rest = _objectWithoutProperties(props, ["placeholder", "value", "onChange", "state", "label", "inputSize", "type", "textareaResize", "notification", "className", "style", "addonAfter", "addonBefore", "disabled"]);

  var customProps = {
    inputSize: inputSize,
    state: state
  };

  var commonProps = _objectSpread({
    ref: ref,
    placeholder: placeholder,
    customProps: customProps,
    className: className,
    style: style,
    value: value,
    onChange: onChange,
    disabled: disabled
  }, rest);

  if (props.type === "textarea") {
    return _react.default.createElement(_styledComponents.StyledTextArea, _extends({}, commonProps, {
      textareaResize: textareaResize
    }));
  }

  return _react.default.createElement(_styledComponents.StyledInput, _extends({
    type: props.type === "password" ? "password" : props.type === "number" ? "number" : "text"
  }, commonProps));
});

var _default = RenderInput;
exports.default = _default;