"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AddonIcon = exports.IconBackground = exports.NotificationContainer = exports.StyledLabel = exports.AddonContainer = exports.AddonAfterSpan = exports.AddonBeforeSpan = exports.StyledTextArea = exports.StyledInput = exports.InputWrapper = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var InputWrapper =
/*#__PURE__*/
_styledComponents.default.span.withConfig({
  displayName: "styledComponents__InputWrapper",
  componentId: "l6uaxb-0"
})(["position:relative;display:flex;align-items:center;outline:none;"]); // Common styles for <input> and <textarea>


exports.InputWrapper = InputWrapper;

var commonInputStyles = function commonInputStyles(props) {
  return (0, _styledComponents.css)(["width:100%;position:relative;border-radius:", ";border:", ";padding:", ";box-sizing:border-box;background-color:", ";color:", ";font-size:", ";line-height:", ";transition:border 0.25s ease;&:hover{border:", ";}&:focus,&:active{outline:none;background-color:", ";border:", ";box-shadow:", ";}&:disabled{cursor:not-allowed;background-color:", ";border:", ";box-shadow:none;resize:none;}&::placeholder{color:", ";}&::selection{background-color:", ";}"], (0, _utils.getBorderRadius)(props), (0, _utils.getInputBorder)(props, "default"), (0, _utils.getPadding)(props), (0, _utils.getBackgroundColor)(props), (0, _utils.getColor)(props), "".concat((0, _utils.getFontSize)(props), "rem"), "".concat((0, _utils.getLineHeight)(props), "rem"), (0, _utils.getInputBorder)(props, "hover"), (0, _utils.getBackgroundColor)(props, "focus"), (0, _utils.getInputBorder)(props, "focus"), (0, _utils.getBoxShadow)(props, "active"), (0, _utils.getBackgroundColor)(props), (0, _utils.getInputBorder)(props, "default"), (0, _utils.getColor)(props, "placeholder"), (0, _utils.getSelectionBackground)(props));
};

var StyledInput =
/*#__PURE__*/
_styledComponents.default.input.withConfig({
  displayName: "styledComponents__StyledInput",
  componentId: "l6uaxb-1"
})(["", " min-height:", ";&[type=\"number\"]::-webkit-inner-spin-button{min-height:", ";}"], commonInputStyles, function (props) {
  return (0, _utils.getHeight)(props);
}, function (props) {
  return (0, _utils.getHeight)(props);
});

exports.StyledInput = StyledInput;

var StyledTextArea =
/*#__PURE__*/
_styledComponents.default.textarea.withConfig({
  displayName: "styledComponents__StyledTextArea",
  componentId: "l6uaxb-2"
})(["", " font-family:InterRegular,-apple-system,BlinkMacSystemFont,\"Segoe UI\",Roboto,Helvetica,Arial,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",\"Segoe UI Symbol\";resize:", ";"], commonInputStyles, function (props) {
  return props.textareaResize;
});

exports.StyledTextArea = StyledTextArea;

var AddonSpan =
/*#__PURE__*/
_styledComponents.default.span.withConfig({
  displayName: "styledComponents__AddonSpan",
  componentId: "l6uaxb-3"
})(["display:inline-block;width:100%;position:relative;"]);

var AddonBeforeSpan =
/*#__PURE__*/
(0, _styledComponents.default)(AddonSpan).withConfig({
  displayName: "styledComponents__AddonBeforeSpan",
  componentId: "l6uaxb-4"
})(["& input{padding-left:", "rem;}"], function (props) {
  return (0, _utils.getAddonPadding)(props.iconSize);
});
exports.AddonBeforeSpan = AddonBeforeSpan;
var AddonAfterSpan =
/*#__PURE__*/
(0, _styledComponents.default)(AddonSpan).withConfig({
  displayName: "styledComponents__AddonAfterSpan",
  componentId: "l6uaxb-5"
})(["& input{padding-right:", "rem;}"], function (props) {
  return (0, _utils.getAddonPadding)(props.iconSize);
});
exports.AddonAfterSpan = AddonAfterSpan;

var AddonContainer =
/*#__PURE__*/
_styledComponents.default.span.withConfig({
  displayName: "styledComponents__AddonContainer",
  componentId: "l6uaxb-6"
})(["display:flex;position:absolute;top:50%;transform:translateY(-50%);"]);

exports.AddonContainer = AddonContainer;
var labelStyle =
/*#__PURE__*/
(0, _styledComponents.css)(["display:block;font-size:1.2rem;line-height:1.8rem;"]);

var StyledLabel =
/*#__PURE__*/
_styledComponents.default.label.withConfig({
  displayName: "styledComponents__StyledLabel",
  componentId: "l6uaxb-7"
})(["", " text-transform:uppercase;color:", ";"], labelStyle, function (props) {
  return (0, _utils.getColor)(props, "label");
});

exports.StyledLabel = StyledLabel;

var NotificationContainer =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "styledComponents__NotificationContainer",
  componentId: "l6uaxb-8"
})(["", " color:", ";"], labelStyle, function (props) {
  return (0, _utils.getColor)(props, "notification");
});

exports.NotificationContainer = NotificationContainer;

var IconBackground =
/*#__PURE__*/
_styledComponents.default.span.withConfig({
  displayName: "styledComponents__IconBackground",
  componentId: "l6uaxb-9"
})(["display:inline-block;height:", ";width:", ";border-radius:50%;background-color:#e5e5e5;"], function (props) {
  return props.bgSize;
}, function (props) {
  return props.bgSize;
});

exports.IconBackground = IconBackground;
var AddonIcon =
/*#__PURE__*/
(0, _styledComponents.default)(_Icon.default).withConfig({
  displayName: "styledComponents__AddonIcon",
  componentId: "l6uaxb-10"
})(["", ""], function (props) {
  return props.pointer && "cursor: pointer";
});
exports.AddonIcon = AddonIcon;