"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _commonUtils = require("./commonUtils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var DEFAULT_COLOR_THEME = "neutral";

var getFontSize = function getFontSize(props) {
  var fontSize = props.customProps.fontSize,
      typography = props.theme.knitui.typography;
  return typography[fontSize].fontSize;
};

var geLineHeight = function geLineHeight(props) {
  var fontSize = props.customProps.fontSize,
      typography = props.theme.knitui.typography;
  return typography[fontSize].lineHeight;
};

var verticalPadding = "0rem";

var getHorizontalPadding = function getHorizontalPadding(props) {
  var expanded = props.customProps.expanded;
  return expanded ? "0.3rem" : "0rem";
};

var StyledDiv =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "InlineLabel__StyledDiv",
  componentId: "so3hud-0"
})(["display:inline-flex;align-items:center;padding:", ";background-color:", ";color:", ";font-size:", ";line-height:", ";box-sizing:border-box;"], function (props) {
  return "".concat(verticalPadding, " ").concat(getHorizontalPadding(props));
}, function (props) {
  return (0, _commonUtils.getBackgroundColor)(props);
}, function (props) {
  return (0, _commonUtils.getFontColor)(props);
}, function (props) {
  return "".concat(getFontSize(props), "rem");
}, function (props) {
  return "".concat(geLineHeight(props), "rem");
});

var InlineLabel = function InlineLabel(_ref) {
  var className = _ref.className,
      style = _ref.style,
      rest = _objectWithoutProperties(_ref, ["className", "style"]);

  var text = rest.text;
  var scProps = {
    className: className,
    style: style,
    customProps: rest
  };
  return _react.default.createElement(StyledDiv, _extends({}, scProps, {
    className: className,
    style: style
  }), _react.default.createElement("span", null, text));
};

InlineLabel.defaultProps = {
  expanded: false,
  fontSize: 12,
  colorPreset: DEFAULT_COLOR_THEME
};
var _default = InlineLabel;
exports.default = _default;