"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFontColor = exports.getBackgroundColor = exports.parseColorTheme = void 0;

var _utils = require("../../common/_utils");

var parseColorTheme = function parseColorTheme(props) {
  var _props$customProps = props.customProps,
      customColor = _props$customProps.customColor,
      colorPreset = _props$customProps.colorPreset,
      theme = props.theme.knitui;
  return customColor ? (0, _utils.parseCustomColor)(theme, customColor) : (0, _utils.parseColorPreset)(theme, colorPreset);
};

exports.parseColorTheme = parseColorTheme;

var getBackgroundColor = function getBackgroundColor(props) {
  return parseColorTheme(props).background;
};

exports.getBackgroundColor = getBackgroundColor;

var getFontColor = function getFontColor(props) {
  var customFontColor = props.customProps.customFontColor;
  return customFontColor || parseColorTheme(props).font;
};

exports.getFontColor = getFontColor;