"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var rotate =
/*#__PURE__*/
(0, _styledComponents.keyframes)(["100%{transform:rotate(360deg);}"]);
var dash =
/*#__PURE__*/
(0, _styledComponents.keyframes)(["0%{stroke-dasharray:1,200;stroke-dashoffset:0;}50%{stroke-dasharray:89,200;stroke-dashoffset:-35;}100%{stroke-dasharray:89,200;stroke-dashoffset:-124;}"]);

var SVG =
/*#__PURE__*/
_styledComponents.default.svg.withConfig({
  displayName: "IconLoader__SVG",
  componentId: "sc-18c9cio-0"
})(["animation:", " 2s linear infinite;height:100%;transform-origin:center center;width:100%;padding:0.2rem;position:absolute;top:0;bottom:0;left:0;right:0;margin:auto;"], rotate);

var Path =
/*#__PURE__*/
_styledComponents.default.circle.withConfig({
  displayName: "IconLoader__Path",
  componentId: "sc-18c9cio-1"
})(["stroke-dasharray:100,200;stroke-dashoffset:0;animation:", " 1.5s ease-in-out infinite;stroke-linecap:round;stroke:", ";"], dash, function (_ref) {
  var stroke = _ref.stroke,
      theme = _ref.theme;
  return stroke || theme.knitui.chromaPalette.Neutral90;
});

var LoaderWrapper =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "IconLoader__LoaderWrapper",
  componentId: "sc-18c9cio-2"
})(["position:relative;width:", ";height:", ";"], function (_ref2) {
  var size = _ref2.size;
  return size;
}, function (_ref3) {
  var size = _ref3.size;
  return size;
});

var IconLoader = function IconLoader(props) {
  var _props$size = props.size,
      size = _props$size === void 0 ? "1.8rem" : _props$size,
      _props$strokeWidth = props.strokeWidth,
      strokeWidth = _props$strokeWidth === void 0 ? 4 : _props$strokeWidth,
      fill = props.fill;
  return _react.default.createElement(LoaderWrapper, {
    size: size
  }, _react.default.createElement(SVG, {
    viewBox: "25 25 50 50"
  }, _react.default.createElement(Path, {
    cx: "50",
    cy: "50",
    r: "20",
    fill: "none",
    strokeMiterlimit: "10",
    strokeWidth: strokeWidth,
    stroke: fill
  })));
};

var _default = IconLoader;
exports.default = _default;