"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getPadding = function getPadding(props) {
  var knitui = props.theme.knitui,
      padding = props.customProps.padding;
  return padding ? "".concat(padding.vertical, " ").concat(padding.horizontal) : "".concat(knitui.modalPadding.vertical, "rem ").concat(knitui.modalPadding.horizontal, "rem");
};

var StyledMain =
/*#__PURE__*/
_styledComponents.default.div.attrs(function () {
  return {
    "data-testid": "knit-modal-body"
  };
}).withConfig({
  displayName: "Main__StyledMain",
  componentId: "sc-18bo4wn-0"
})(["padding:", ";overflow:auto;flex:1 1 auto;"], function (props) {
  return getPadding(props);
});

var Main = _react.default.forwardRef(function (props, ref) {
  var children = props.children,
      _props$customProps = props.customProps,
      customProps = _props$customProps === void 0 ? {} : _props$customProps;
  return _react.default.createElement(StyledMain, {
    ref: ref,
    customProps: customProps
  }, children);
});

Main.defaultProps = {
  padding: {
    vertical: "2.8rem",
    horizontal: "2.1rem"
  }
};
var _default = Main;
exports.default = _default;