"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _components = require("../components");

var _styledComponents = require("./styledComponents");

var _helpers = require("../helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BaseModal = function BaseModal(_ref) {
  var maxContentHeight = _ref.maxContentHeight,
      minContentHeight = _ref.minContentHeight,
      padding = _ref.padding,
      children = _ref.children;

  var childrenArray = _react.default.Children.toArray(children);

  var childrenToRender = (0, _helpers.getChildrenWithTypes)(childrenArray);
  return _react.default.createElement(_styledComponents.BaseLayout, null, _react.default.createElement(_components.Header, null, childrenToRender["header"]), _react.default.createElement(_styledComponents.VerticalLayoutContent, {
    customProps: {
      maxContentHeight: maxContentHeight,
      minContentHeight: minContentHeight
    }
  }, _react.default.createElement(_components.ScrollWrapper, {
    padding: padding
  }, childrenToRender["body"], childrenToRender["footer"])));
};

var _default = BaseModal;
exports.default = _default;