"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _rcDialog = _interopRequireDefault(require("rc-dialog"));

var _Input = _interopRequireDefault(require("../Input"));

require("rc-dialog/assets/index.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var StyledDialog =
/*#__PURE__*/
(0, _styledComponents.default)(_rcDialog.default).withConfig({
  displayName: "OmniSearch__StyledDialog",
  componentId: "sc-1jbk1wu-0"
})([".rc-dialog-body{padding:7px 0;}"]);

var InputWrapper =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "OmniSearch__InputWrapper",
  componentId: "sc-1jbk1wu-1"
})(["padding:0.7rem 1.4rem;"]);

var StyledInput =
/*#__PURE__*/
_styledComponents.default.input.withConfig({
  displayName: "OmniSearch__StyledInput",
  componentId: "sc-1jbk1wu-2"
})(["width:100%;border:none;font-size:1.6rem;margin-left:1rem;height:2rem;&::placeholder{color:", ";}"], function (props) {
  return getColor(props, "Neutral45");
});

var getColor = function getColor(props, color) {
  var knitui = props.theme.knitui;
  return knitui.chromaPalette[color];
};

var OmniSearch =
/*#__PURE__*/
function (_Component) {
  _inherits(OmniSearch, _Component);

  function OmniSearch(props) {
    var _this;

    _classCallCheck(this, OmniSearch);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(OmniSearch).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "searchRef", void 0);

    _defineProperty(_assertThisInitialized(_this), "focusSearch", function () {
      return _this.searchRef.current && _this.searchRef.current.focus();
    });

    _this.searchRef = _react.default.createRef();
    return _this;
  }

  _createClass(OmniSearch, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var visible = this.props.visible;

      if (visible && !prevProps.visible) {
        this.focusSearch();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          visible = _this$props.visible,
          onClose = _this$props.onClose,
          onChange = _this$props.onChange,
          _this$props$value = _this$props.value,
          value = _this$props$value === void 0 ? "" : _this$props$value,
          _this$props$dropdown = _this$props.dropdown,
          dropdown = _this$props$dropdown === void 0 ? null : _this$props$dropdown,
          _this$props$placehold = _this$props.placeholder,
          placeholder = _this$props$placehold === void 0 ? "Search for a report" : _this$props$placehold;
      return _react.default.createElement(StyledDialog, {
        visible: visible,
        onClose: onClose,
        closable: false
      }, _react.default.createElement(InputWrapper, null, _react.default.createElement(_Input.default, {
        type: "search",
        role: "search",
        autoFocus: true,
        inputSize: "large",
        value: value,
        onChange: onChange,
        onBlur: this.focusSearch,
        placeholder: placeholder,
        ref: this.searchRef
      })), dropdown);
    }
  }]);

  return OmniSearch;
}(_react.Component);

var _default = OmniSearch;
exports.default = _default;