"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Avatar = _interopRequireDefault(require("../../Avatar"));

var _Icon = _interopRequireDefault(require("../../Icon"));

var _Label = _interopRequireDefault(require("../../Label"));

var _Option = require("./Option.styles");

var _OptionGroup = _interopRequireDefault(require("./OptionGroup"));

var _OptionText = _interopRequireDefault(require("./OptionText"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Option = function Option(props) {
  var value = props.value,
      customStyles = props.customStyles,
      onClick = props.onClick,
      children = props.children,
      selected = props.selected,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      rest = _objectWithoutProperties(props, ["value", "customStyles", "onClick", "children", "selected", "disabled"]); // Pass disabled props to all children


  var updatedChildren = _react.Children.map(children, function (child) {
    return (0, _react.cloneElement)(child, {
      disabled: disabled
    });
  }); // Filter children based on their alignment


  var rightChildren = _react.Children.toArray(updatedChildren).filter(function (comp) {
    return comp.props.align === "right";
  });

  var leftChildren = _react.Children.toArray(updatedChildren).filter(function (comp) {
    return comp.props.align !== "right";
  });

  return _react.default.createElement(_Option.OptionWrapper, _extends({
    onClick: onClick ? function (e) {
      return onClick(e, value);
    } : function () {
      return null;
    },
    style: customStyles,
    isDisabled: disabled,
    selected: selected
  }, rest), !children && _react.default.createElement(Option.Text, null, value), _react.default.createElement(_Option.FlexWrapper, null, leftChildren), _react.default.createElement(_Option.FlexWrapper, {
    align: "right"
  }, rightChildren, selected && _react.default.createElement(Option.Icon, {
    type: "oCheck",
    align: "right"
  })));
}; // Wrap all option sub-components in a common wrapper and pass all props to the corresponding component


Option.Icon = (0, _Option.OptionItemWrapper)(_Icon.default, {});
Option.Text = (0, _Option.OptionItemWrapper)(_OptionText.default, {});
Option.Tag = (0, _Option.OptionItemWrapper)(_Label.default, {});
Option.Avatar = (0, _Option.OptionItemWrapper)(_Avatar.default, {
  alignStart: true
});
Option.Group = _OptionGroup.default;
Option.Divider = _Option.StyledDivider;
var _default = Option;
exports.default = _default;