"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OptionItemWrapper = exports.StyledIcon = exports.StyledDivider = exports.FlexWrapper = exports.StyledOptionText = exports.VerticalWrapper = exports.OptionDescription = exports.OptionWrapper = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _utils = require("../../../common/_utils");

var _Icon = _interopRequireDefault(require("../../Icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var OptionWrapper =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Optionstyles__OptionWrapper",
  componentId: "sc-18ji9y6-0"
})(["font-size:1.4rem;line-height:2rem;display:flex;align-items:center;justify-content:space-between;color:", ";padding:0.7rem 1.4rem;border:0.1rem solid transparent;cursor:default;overflow:hidden;background-color:", ";", ""], function (props) {
  return (0, _utils.getThemeColor)(props, "Neutral90");
}, function (props) {
  return (0, _utils.getThemeColor)(props, props.selected ? "Neutral10" : "Neutral0");
}, function (_ref) {
  var isDisabled = _ref.isDisabled;
  return !isDisabled ? (0, _styledComponents.css)(["&:active{border:0.1rem solid ", ";box-shadow:0 0 0.2rem #0066ff;z-index:1;}&:hover{background-color:", ";}"], function (props) {
    return (0, _utils.getThemeColor)(props, "Azure80");
  }, function (props) {
    return (0, _utils.getThemeColor)(props, "Neutral10");
  }) : (0, _styledComponents.css)(["cursor:not-allowed;opacity:0.6;&:active{pointer-events:none;}"]);
});

exports.OptionWrapper = OptionWrapper;

var OptionDescription =
/*#__PURE__*/
_styledComponents.default.span.withConfig({
  displayName: "Optionstyles__OptionDescription",
  componentId: "sc-18ji9y6-1"
})(["font-size:1.2rem;line-height:1.8rem;color:", ";"], function (props) {
  return (0, _utils.getThemeColor)(props, "Neutral50");
});

exports.OptionDescription = OptionDescription;

var VerticalWrapper =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Optionstyles__VerticalWrapper",
  componentId: "sc-18ji9y6-2"
})(["display:flex;flex-direction:column;overflow:hidden;"]);

exports.VerticalWrapper = VerticalWrapper;

var StyledOptionText =
/*#__PURE__*/
_styledComponents.default.span.withConfig({
  displayName: "Optionstyles__StyledOptionText",
  componentId: "sc-18ji9y6-3"
})(["white-space:nowrap;text-overflow:ellipsis;overflow:hidden;"]);

exports.StyledOptionText = StyledOptionText;

var FlexWrapper =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Optionstyles__FlexWrapper",
  componentId: "sc-18ji9y6-4"
})(["display:flex;align-items:center;overflow:", ";"], function (props) {
  return props.align === "right" ? 'initial' : 'hidden';
});

exports.FlexWrapper = FlexWrapper;

var StyledDivider =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Optionstyles__StyledDivider",
  componentId: "sc-18ji9y6-5"
})(["margin:0.7rem 0;background-color:", ";height:0.1rem;"], function (props) {
  return (0, _utils.getThemeColor)(props, "Neutral20");
});

exports.StyledDivider = StyledDivider;
var StyledIcon =
/*#__PURE__*/
(0, _styledComponents.default)(_Icon.default).withConfig({
  displayName: "Optionstyles__StyledIcon",
  componentId: "sc-18ji9y6-6"
})(["margin-right:", ";margin-left:", ";"], function (props) {
  return props.align === "right" ? 0 : "1.5rem";
}, function (props) {
  return props.align === "right" ? "1.5rem" : 0;
}); // Generic component wrapper which styles a component and adds appropriate styles based on the position

exports.StyledIcon = StyledIcon;

var OptionItemWrapper = function OptionItemWrapper(component, customProps) {
  return (0, _styledComponents.default)(component).withConfig({
    displayName: "Optionstyles",
    componentId: "sc-18ji9y6-7"
  })(["margin-right:", ";margin-left:", ";&:first-child{margin-left:0;}align-self:", ";"], function (props) {
    return props.align === "right" ? 0 : "1.5rem";
  }, function (props) {
    return props.align === "right" ? "1.5rem" : 0;
  }, customProps && customProps.alignStart ? "flex-start" : "center");
};

exports.OptionItemWrapper = OptionItemWrapper;