"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _Radio = _interopRequireDefault(require("./Radio"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var renderRadio = function renderRadio(props, value, setValue) {
  var propsToPass = _lodash.default.omit(props, ["children", "defaultValue"]);

  var Radios = props.children || _react.default.createElement(_react.default.Fragment, null);

  if (!Array.isArray(Radios)) Radios = _react.default.Children.toArray(Radios);
  return Radios.map(function (radio, index) {
    return (0, _react.cloneElement)(radio, _objectSpread({
      setValue: setValue,
      style: props.style,
      key: index,
      checked: value === radio.props.value
    }, propsToPass));
  });
};

var getDefaultValue = function getDefaultValue(radios) {
  var child = _react.default.Children.count(radios);

  if (child < 2) {
    // Optionally throw error if need be
    console.error("Add 2 or more Radio Items to the Group");
  }

  switch (true) {
    case child > 1:
      var len = radios.length - 1;

      for (var radio in radios) {
        if (radios[len - Number(radio)].props.checked) {
          return radios[len - Number(radio)].props.value;
        }
      }

      return null;

    case child === 1:
      /**
       * In some cases if child is rendered using <RadioGroup>{[].map(val => val)}</RadioGroup>
       * it always pass structure as array. We have to detect the structure first & then manipulate
       */
      var singleRadio = Array.isArray(radios) ? radios[0] : radios;
      return singleRadio.props.checked ? singleRadio.props.value : null;

    default:
      return null;
  }
};

var RadioGroup = function RadioGroup(props) {
  var radioValue = getDefaultValue(props.children);

  var _useState = (0, _react.useState)(radioValue || props.defaultValue),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  return _react.default.createElement(_react.default.Fragment, null, renderRadio(props, value, setValue));
};

RadioGroup.defaultProps = {
  size: "medium"
};
RadioGroup.Item = _Radio.default;
var _default = RadioGroup;
exports.default = _default;