"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledRadio = require("./styledRadio");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var RadioWrapper = function RadioWrapper(props) {
  var prefixCls = props.prefixCls,
      className = props.className,
      style = props.style,
      size = props.size,
      disabled = props.disabled,
      readOnly = props.readOnly,
      tabIndex = props.tabIndex,
      onClick = props.onClick,
      onFocus = props.onFocus,
      onBlur = props.onBlur,
      autoFocus = props.autoFocus,
      onChange = props.onChange,
      value = props.value,
      checked = props.checked,
      setValue = props.setValue,
      others = _objectWithoutProperties(props, ["prefixCls", "className", "style", "size", "disabled", "readOnly", "tabIndex", "onClick", "onFocus", "onBlur", "autoFocus", "onChange", "value", "checked", "setValue"]);

  var handleChange = function handleChange(e) {
    if (props.disabled) {
      return;
    }

    if (setValue) {
      setValue(value);
    }

    if (onChange) {
      onChange({
        target: _objectSpread({}, props, {
          checked: e.target.checked
        }),
        stopPropagation: function stopPropagation() {
          e.stopPropagation();
        },
        preventDefault: function preventDefault() {
          e.preventDefault();
        },
        nativeEvent: e.nativeEvent
      });
    }
  }; // https://github.com/react-component/checkbox/blob/3efbcecbe41533c90a0844d836adbc28c8b0a7ff/src/Checkbox.jsx#L116
  // Pass aria and data, props, role the the created element


  var globalProps = Object.keys(others).reduce(function (prev, key) {
    if (key.substr(0, 5) === "aria-" || key.substr(0, 5) === "data-" || key === "role") {
      prev[key] = others[key];
    }

    return prev;
  }, {});
  var checkedClass = checked ? "".concat(prefixCls, "-checked") : "";
  var disabledClass = props.disabled ? "".concat(prefixCls, "-disabled") : "";
  var rootClass = "".concat(prefixCls, " ").concat(className || "", " ").concat(checkedClass, " ").concat(disabledClass);
  var styleProps = {
    size: size,
    disabled: disabled
  };
  return _react.default.createElement(_styledRadio.StyledRadioRoot, _extends({
    className: rootClass
  }, styleProps, {
    style: style
  }), _react.default.createElement(_styledRadio.StyledRadioInput, _extends({
    name: name,
    type: "radio",
    readOnly: readOnly,
    disabled: disabled,
    tabIndex: tabIndex,
    className: "".concat(prefixCls, "-input"),
    checked: checked,
    onClick: onClick,
    onFocus: onFocus,
    onBlur: onBlur,
    onChange: handleChange,
    autoFocus: autoFocus,
    value: value
  }, globalProps)), _react.default.createElement(_styledRadio.StyledRadioInner, _extends({}, styleProps, {
    className: "".concat(prefixCls, "-inner")
  })));
};

RadioWrapper.defaultProps = {
  prefixCls: "knit-radio",
  className: "",
  style: {},
  size: "medium",
  onFocus: function onFocus() {},
  onBlur: function onBlur() {},
  onChange: function onChange() {}
};
var _default = RadioWrapper;
exports.default = _default;