"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledRadioInput = exports.StyledRadioInner = exports.StyledRadioRoot = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _utils = require("../../common/_utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isSmall = function isSmall(size) {
  return size === "small";
};

var isDisabled = function isDisabled(props) {
  return props.disabled;
}; // helper to get radio size


var getRadioSize = function getRadioSize(theme, size) {
  return isSmall(size) ? theme.knitui.smallRadioSize : theme.knitui.mediumRadioSize;
}; // helper to get radio bead size


var getRadioBeadSize = function getRadioBeadSize(theme, size) {
  return isSmall(size) ? theme.knitui.smallRadioBead : theme.knitui.mediumRadioBead;
};

var StyledRadioRoot =
/*#__PURE__*/
_styledComponents.default.span.withConfig({
  displayName: "styledRadio__StyledRadioRoot",
  componentId: "sc-1j83n3u-0"
})(["&.knit-radio{white-space:nowrap;outline:none;display:inline-block;position:relative;& + span{cursor:", ";margin-left:10px;}&.knit-radio-checked{.knit-radio-inner{&::after{opacity:1;}}}&.knit-radio-disabled{.knit-radio-inner{cursor:not-allowed;opacity:0.6;background-color:", ";}& + span{color:", ";}.knit-radio-input{cursor:not-allowed;}}}"], function (props) {
  return isDisabled(props) ? "not-allowed" : "pointer";
}, function (_ref) {
  var theme = _ref.theme;
  return theme.knitui.radioDisabledColor;
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Neutral50");
}); // prettier-ignore-next-line


exports.StyledRadioRoot = StyledRadioRoot;

var StyledRadioInner =
/*#__PURE__*/
_styledComponents.default.span.withConfig({
  displayName: "styledRadio__StyledRadioInner",
  componentId: "sc-1j83n3u-1"
})(["position:relative;top:0;left:0;display:inline-block;width:", ";height:", ";border-width:1px;cursor:pointer;border-style:solid;border-radius:14px;border-color:", ";background-color:", ";&::after{position:absolute;width:", ";height:", ";top:50%;left:50%;transform:translate(-50%,-50%);border-radius:0.7rem;border-top:0;border-left:0;content:\" \";background-color:", ";opacity:0;}&:focus{box-shadow:0px 0px 2px ", ";outline:none;}"], function (_ref2) {
  var theme = _ref2.theme,
      size = _ref2.size;
  return getRadioSize(theme, size);
}, function (_ref3) {
  var theme = _ref3.theme,
      size = _ref3.size;
  return getRadioSize(theme, size);
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Blue100");
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Neutral0");
}, function (_ref4) {
  var theme = _ref4.theme,
      size = _ref4.size;
  return getRadioBeadSize(theme, size);
}, function (_ref5) {
  var theme = _ref5.theme,
      size = _ref5.size;
  return getRadioBeadSize(theme, size);
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Blue100");
}, function (_ref6) {
  var theme = _ref6.theme;
  return theme.knitui.switchFocusColor;
});

exports.StyledRadioInner = StyledRadioInner;

var StyledRadioInput =
/*#__PURE__*/
_styledComponents.default.input.withConfig({
  displayName: "styledRadio__StyledRadioInput",
  componentId: "sc-1j83n3u-2"
})(["position:absolute;left:0;cursor:pointer;opacity:0;top:0;bottom:0;right:0;"]);

exports.StyledRadioInput = StyledRadioInput;