"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Shimmer;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var shim =
/*#__PURE__*/
(0, _styledComponents.keyframes)(["from{left:-110%;}to{left:110%;}"]);

function getHeight(height) {
  switch (height) {
    case "large":
      return 3.2;

    case "medium":
      return 2.8;

    default:
      return 2;
  }
}

var ShimmerContainer =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Shimmer__ShimmerContainer",
  componentId: "sc-1yky23q-0"
})(["width:100%;height:", ";background:", ";border-radius:4px;position:relative;overflow:hidden;"], function (_ref) {
  var customProps = _ref.customProps;
  return "".concat(getHeight(customProps.height), "rem");
}, function (_ref2) {
  var theme = _ref2.theme;
  return theme.knitui.chromaPalette.Neutral10;
});

var ShimmerElement =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Shimmer__ShimmerElement",
  componentId: "sc-1yky23q-1"
})(["width:50%;max-width:35rem;background:rgba(204,204,204,0.3);height:100%;border-radius:4px;box-shadow:0px 14px 70px rgba(0,0,0,0.3);animation:", " 2000ms cubic-bezier(0.5,0,0,1) infinite;position:absolute;", ";"], shim, function (_ref3) {
  var animationOverrides = _ref3.animationOverrides;
  return animationOverrides;
});

function Shimmer(_ref4) {
  var _ref4$height = _ref4.height,
      height = _ref4$height === void 0 ? "small" : _ref4$height,
      className = _ref4.className,
      style = _ref4.style,
      _ref4$animationOverri = _ref4.animationOverrides,
      animationOverrides = _ref4$animationOverri === void 0 ? {} : _ref4$animationOverri;
  return _react.default.createElement(ShimmerContainer, {
    className: className,
    style: style,
    customProps: {
      height: height
    }
  }, _react.default.createElement(ShimmerElement, {
    animationOverrides: animationOverrides
  }));
}