"use strict";

function _templateObject() {
  var data = _taggedTemplateLiteral(["", ""]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabItem = exports.TabDragElement = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _react = _interopRequireDefault(require("react"));

var _reactSortableHoc = require("react-sortable-hoc");

var _styles = require("./styles");

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TabDragElement = (0, _reactSortableHoc.SortableHandle)(function (_ref) {
  var children = _ref.children;
  return children;
});
exports.TabDragElement = TabDragElement;
var TabItem = (0, _reactSortableHoc.SortableElement)(function (_ref2) {
  var value = _ref2.value,
      onChange = _ref2.onChange,
      activeKey = _ref2.activeKey,
      activeKeyIndex = _ref2.activeKeyIndex,
      itemIndex = _ref2.itemIndex,
      activeTabFlags = _ref2.activeTabFlags,
      itemRef = _ref2.itemRef,
      activeNxtRef = _ref2.activeNxtRef,
      activePrevRef = _ref2.activePrevRef,
      dragHandle = _ref2.dragHandle,
      DragHandleElement = _ref2.dragHandleElement,
      readOnly = _ref2.readOnly,
      customColor = _ref2.customColor;
  var props = value.props;
  var isActive = props.tabKey === activeKey;
  var handleElement = dragHandle && isActive && !readOnly ? _react.default.createElement(TabDragElement, null, DragHandleElement ? _react.default.createElement(DragHandleElement, null) : _react.default.createElement(_styles.DragIcon, {
    type: "oDragIndicator",
    size: "16px"
  })) : null;

  var elem = _react.default.cloneElement(value, {
    key: props.tabKey,
    active: isActive,
    dragHandle: dragHandle,
    role: "tab",
    "aria-controls": "tabpanel-id",
    customColor: customColor,
    children: [handleElement, props.tab],
    onClick: function onClick() {
      return !isActive && onChange(props.tabKey);
    }
  });

  var showVBar = itemIndex + 1 !== activeKeyIndex && !isActive;
  var styles = (0, _utils.getTabContainerStyle)(activeTabFlags, activeKeyIndex, itemIndex, itemRef);

  var getRef = function getRef() {
    if (activeKeyIndex === itemIndex) {
      return itemRef;
    } else if (activeKeyIndex + 1 === itemIndex) {
      return activeNxtRef;
    } else if (activeKeyIndex - 1 === itemIndex) {
      return activePrevRef;
    }

    return null;
  };

  return _react.default.createElement(_StyledDiv, {
    ref: getRef(),
    id: isActive ? "knit-active-tab" : "",
    _css: styles
  }, elem, showVBar ? _react.default.createElement(_styles.VerticalBar, {
    tabIndex: -1
  }) : null);
});
exports.TabItem = TabItem;

var _StyledDiv = (0, _styledComponents.default)("div")(_templateObject(), function (p) {
  return p._css;
});