"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _arrayMove = _interopRequireDefault(require("array-move"));

var _ = require("..");

var _TabsList = require("./TabsList");

var _styles = require("./styles");

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var getActiveKeyIndex = function getActiveKeyIndex(childrenArray, activeKey) {
  return childrenArray.findIndex(function (child) {
    return child.props.tabKey === activeKey;
  });
};

var onScroll = function onScroll(listRef, activeNxtRef, itemRef, activePrevRef, setActiveTabFlags, setScrollFlags) {
  var current = listRef.current;

  if (!current) {
    return;
  }

  if (activeNxtRef.current && itemRef.current && current.offsetLeft + current.scrollLeft + itemRef.current.clientWidth >= activeNxtRef.current.offsetLeft) {
    setActiveTabFlags({
      right: false,
      left: true
    });
  } else if (activePrevRef.current && itemRef.current && current.offsetLeft + current.scrollLeft + current.clientWidth <= activePrevRef.current.offsetLeft + activePrevRef.current.clientWidth + itemRef.current.clientWidth) {
    setActiveTabFlags({
      right: true,
      left: false
    });
  } else {
    setActiveTabFlags({
      right: false,
      left: false
    });
  }

  var leftSideScroll = current.scrollLeft > 0;
  var rightSideScroll = current.scrollLeft !== current.scrollWidth - current.offsetWidth;
  var scrollFlags = {
    leftSideScroll: leftSideScroll,
    rightSideScroll: rightSideScroll
  };
  setScrollFlags(scrollFlags);
};

var Tabs = function Tabs(_ref) {
  var children = _ref.children,
      tabProps = _objectWithoutProperties(_ref, ["children"]);

  var childrenArrayProps = _react.Children.toArray(children);

  var firstTab = childrenArrayProps[0] && childrenArrayProps[0].props.tabKey;
  var internalState = (0, _react.useState)(tabProps.defaultActiveKey || firstTab);
  var _tabProps$activeKey = tabProps.activeKey,
      activeKey = _tabProps$activeKey === void 0 ? internalState[0] : _tabProps$activeKey,
      _tabProps$onChange = tabProps.onChange,
      onChange = _tabProps$onChange === void 0 ? internalState[1] : _tabProps$onChange,
      onAddTab = tabProps.onAddTab,
      onOrderChange = tabProps.onOrderChange,
      _tabProps$pressDelay = tabProps.pressDelay,
      pressDelay = _tabProps$pressDelay === void 0 ? 100 : _tabProps$pressDelay,
      _tabProps$hideTabCont = tabProps.hideTabContent,
      hideTabContent = _tabProps$hideTabCont === void 0 ? false : _tabProps$hideTabCont,
      _tabProps$useDragHand = tabProps.useDragHandle,
      useDragHandle = _tabProps$useDragHand === void 0 ? false : _tabProps$useDragHand,
      _tabProps$dragHandleE = tabProps.dragHandleElement,
      dragHandleElement = _tabProps$dragHandleE === void 0 ? null : _tabProps$dragHandleE,
      _tabProps$readOnly = tabProps.readOnly,
      readOnly = _tabProps$readOnly === void 0 ? false : _tabProps$readOnly,
      _tabProps$hideAdd = tabProps.hideAdd,
      hideAdd = _tabProps$hideAdd === void 0 ? false : _tabProps$hideAdd,
      addButtonElement = tabProps.addButtonElement,
      _tabProps$customColor = tabProps.customColor,
      customColor = _tabProps$customColor === void 0 ? _utils.DEFAULT_COLOR : _tabProps$customColor,
      _tabProps$lockOffset = tabProps.lockOffset,
      lockOffset = _tabProps$lockOffset === void 0 ? 100 : _tabProps$lockOffset;

  var _useState = (0, _react.useState)([]),
      _useState2 = _slicedToArray(_useState, 2),
      childrenArray = _useState2[0],
      setChildrenArray = _useState2[1];

  var _useState3 = (0, _react.useState)(0),
      _useState4 = _slicedToArray(_useState3, 2),
      activeKeyIndex = _useState4[0],
      setActiveKeyIndex = _useState4[1];

  var _useState5 = (0, _react.useState)({
    leftSideScroll: false,
    rightSideScroll: false
  }),
      _useState6 = _slicedToArray(_useState5, 2),
      scrollFlags = _useState6[0],
      setScrollFlags = _useState6[1];

  var _useState7 = (0, _react.useState)({
    right: false,
    left: false
  }),
      _useState8 = _slicedToArray(_useState7, 2),
      activeTabFlags = _useState8[0],
      setActiveTabFlags = _useState8[1]; // ref for main scrollable list container


  var listRef = (0, _react.useRef)(null); // ref for active tab

  var itemRef = (0, _react.useRef)(null); // ref for tab after active tab

  var activeNxtRef = (0, _react.useRef)(null); // ref for tab before active tab

  var activePrevRef = (0, _react.useRef)(null); // ref for left-arrow wrapper, instead of hard code width better to use ref.

  var leftArrowRef = (0, _react.useRef)(null); // ref for right-arrow wrapper, instead of hard code width better to use ref.

  var rightArrowRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    var current = listRef.current;
    current && current.addEventListener("scroll", function () {
      return onScroll(listRef, activeNxtRef, itemRef, activePrevRef, setActiveTabFlags, setScrollFlags);
    });
  }, []);
  (0, _react.useEffect)(function () {
    setChildrenArray(childrenArrayProps);
  }, [children]);
  (0, _react.useEffect)(function () {
    var index = getActiveKeyIndex(childrenArray, activeKey);
    setActiveKeyIndex(index);
  }, [childrenArray, activeKey]);
  (0, _react.useEffect)(function () {
    onScroll(listRef, activeNxtRef, itemRef, activePrevRef, setActiveTabFlags, setScrollFlags);
  }, [activeKeyIndex]);

  var getTabsContent = function getTabsContent() {
    return childrenArray.map(function (child) {
      var key = child.props.tabKey;
      var active = key === activeKey;
      if (active) return child.props.children;
      return _react.default.createElement("div", {
        key: key
      });
    });
  };

  var onSortEnd = function onSortEnd(_ref2) {
    var oldIndex = _ref2.oldIndex,
        newIndex = _ref2.newIndex;
    var newChildren = (0, _arrayMove.default)(childrenArray, oldIndex, newIndex);
    setChildrenArray(newChildren);
    onOrderChange && onOrderChange({
      oldIndex: oldIndex,
      newIndex: newIndex
    });
    document.body.style.cursor = "default";
  };

  var onSortStart = function onSortStart() {
    document.body.style.cursor = "grabbing";
  };

  var handleScrollRight = function handleScrollRight() {
    var list = listRef.current;

    if (list) {
      var distance = list.clientWidth + list.scrollLeft - 140 * 2;
      list.scrollTo({
        behavior: "smooth",
        left: distance
      });
    }
  };

  var handleScrollLeft = function handleScrollLeft() {
    var list = listRef.current;

    if (list) {
      var distance = list.scrollLeft + 140 * 2 - list.clientWidth;
      list.scrollTo({
        behavior: "smooth",
        left: distance
      });
    }
  };

  var AddButtonElement = addButtonElement && _react.default.cloneElement(addButtonElement, {
    onClick: onAddTab,
    disabled: readOnly
  });

  var showRightArrow = scrollFlags.rightSideScroll;
  var showLeftArrow = scrollFlags.leftSideScroll;
  var showRightBlur = showRightArrow && !activeTabFlags.right;
  var showLeftBlur = showLeftArrow && !activeTabFlags.left;
  var showActiveLeftBlur = showLeftArrow && activeTabFlags.left;
  var showActiveRightBlur = showRightArrow && activeTabFlags.right;
  return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_styles.GlobalStyle, {
    customColor: customColor
  }), _react.default.createElement(_styles.TabsWrapper, {
    hideTabContent: hideTabContent
  }, _react.default.createElement(_styles.TabsPanelWrapper, {
    customColor: customColor
  }, _react.default.createElement(_styles.OverflowWrapper, {
    activeTabRef: itemRef
  }, _react.default.createElement(_styles.IconWrapper, {
    ref: leftArrowRef,
    visible: showLeftArrow,
    onClick: handleScrollLeft,
    customColor: customColor
  }, _react.default.createElement(_.Icon, {
    type: "oKeyboardArrowLeft",
    size: "18px",
    fill: "#000000"
  })), _react.default.createElement(_styles.BlurElement, {
    visible: showLeftBlur,
    dir: "left",
    style: {
      left: (0, _utils.getWidthFromRef)(leftArrowRef)
    },
    customColor: customColor
  }), _react.default.createElement(_styles.BlurElement, {
    visible: showActiveLeftBlur,
    dir: "left",
    style: {
      left: (0, _utils.getWidthFromRef)(leftArrowRef) + (0, _utils.getWidthFromRef)(itemRef)
    },
    customColor: customColor
  }), _react.default.createElement(_TabsList.TabsList, {
    listRef: listRef,
    dragHandleElement: dragHandleElement,
    dragHandle: useDragHandle,
    useDragHandle: useDragHandle,
    shouldCancelStart: function shouldCancelStart() {
      return readOnly;
    },
    readOnly: readOnly,
    items: childrenArray,
    activeKey: activeKey,
    activeKeyIndex: activeKeyIndex,
    onSortStart: onSortStart,
    onSortEnd: onSortEnd,
    axis: "x",
    lockAxis: "x",
    pressDelay: pressDelay,
    onChange: onChange,
    activeTabFlags: activeTabFlags,
    itemRef: itemRef,
    activeNxtRef: activeNxtRef,
    activePrevRef: activePrevRef,
    customColor: customColor,
    helperClass: "knitui-tabs-helper",
    lockToContainerEdges: true,
    lockOffset: lockOffset
  }), _react.default.createElement(_styles.BlurElement, {
    visible: showActiveRightBlur,
    dir: "right",
    style: {
      right: (0, _utils.getWidthFromRef)(rightArrowRef) + (0, _utils.getWidthFromRef)(itemRef)
    },
    customColor: customColor
  }), _react.default.createElement(_styles.BlurElement, {
    visible: showRightBlur,
    dir: "right",
    style: {
      right: (0, _utils.getWidthFromRef)(rightArrowRef)
    },
    customColor: customColor
  }), _react.default.createElement(_styles.IconWrapper, {
    ref: rightArrowRef,
    visible: showRightArrow,
    onClick: handleScrollRight,
    customColor: customColor
  }, _react.default.createElement(_.Icon, {
    type: "oKeyboardArrowRight",
    size: "18px",
    fill: "#000000"
  }))), !hideAdd && (AddButtonElement || _react.default.createElement(_styles.ButtonWrapper, {
    disabled: readOnly,
    onClick: onAddTab,
    icon: "oAdd",
    bare: true,
    customColor: "#000000",
    bgColor: customColor
  }))), !hideTabContent && _react.default.createElement(_styles.TabContentWrapper, null, getTabsContent())));
};

Tabs.TabPanel = _styles.TabPanel;
var _default = Tabs;
exports.default = _default;