"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabsList = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactSortableHoc = require("react-sortable-hoc");

var _TabItem = require("./TabItem");

var _styles = require("./styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TabsList = (0, _reactSortableHoc.SortableContainer)(function (_ref) {
  var items = _ref.items,
      onChange = _ref.onChange,
      activeKey = _ref.activeKey,
      activeKeyIndex = _ref.activeKeyIndex,
      activeTabFlags = _ref.activeTabFlags,
      itemRef = _ref.itemRef,
      activeNxtRef = _ref.activeNxtRef,
      activePrevRef = _ref.activePrevRef,
      dragHandle = _ref.dragHandle,
      dragHandleElement = _ref.dragHandleElement,
      readOnly = _ref.readOnly,
      listRef = _ref.listRef,
      customColor = _ref.customColor;
  return _react.default.createElement(_styles.OverflowContainer, {
    ref: listRef
  }, _react.default.createElement("div", null), items.map(function (value, index) {
    return _react.default.createElement(_TabItem.TabItem, {
      readOnly: readOnly,
      dragHandleElement: dragHandleElement,
      dragHandle: dragHandle,
      onChange: onChange,
      key: "tab-".concat(index),
      index: index,
      itemIndex: index,
      value: value,
      activeKey: activeKey,
      activeKeyIndex: activeKeyIndex,
      activeTabFlags: activeTabFlags,
      itemRef: itemRef,
      activeNxtRef: activeNxtRef,
      activePrevRef: activePrevRef,
      customColor: customColor
    });
  }));
});
exports.TabsList = TabsList;