"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.VerticalBar = exports.DragIcon = exports.OverflowContainer = exports.TabContentWrapper = exports.TabPanel = exports.IconWrapper = exports.BlurElement = exports.OverflowWrapper = exports.TabsPanelWrapper = exports.TabsWrapper = exports.ButtonWrapper = exports.GlobalStyle = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _ = require("..");

var _utils = require("../../common/_utils");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n.knitui-tabs-helper:not(#knit-active-tab) {\n  background: ", ";\n  \n  &:before {\n    content: \"\";\n    position: absolute;\n    left: 0;\n    top: 50%;\n    transform: translateY(-50%);\n    height: 1.4rem;\n    width: 1px;\n    background: ", ";\n  }\n}\n\n.knitui-tabs-helper {\n  white-space: nowrap;\n}\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/* The tab being dragged is appended to the body, hence it's styles need to be at global scope*/
var GlobalStyle =
/*#__PURE__*/
(0, _styledComponents.createGlobalStyle)(_templateObject(), function (props) {
  return (0, _utils.getThemeColor)(props, props.customColor);
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Neutral40");
});
exports.GlobalStyle = GlobalStyle;
var ButtonWrapper =
/*#__PURE__*/
(0, _styledComponents.default)(_.Button).withConfig({
  displayName: "styles__ButtonWrapper",
  componentId: "sc-53bvbf-0"
})(["border-radius:4px 4px 0 0;:hover,:focus,:active{background:", ";}"], function (props) {
  return (0, _utils.getColorOfLightness)(props, props.bgColor, 90);
});
exports.ButtonWrapper = ButtonWrapper;

var TabsWrapper =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "styles__TabsWrapper",
  componentId: "sc-53bvbf-1"
})(["height:", ";width:100%;"], function (_ref) {
  var hideTabContent = _ref.hideTabContent;
  return hideTabContent ? "auto" : "100%";
});

exports.TabsWrapper = TabsWrapper;

var TabsPanelWrapper =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "styles__TabsPanelWrapper",
  componentId: "sc-53bvbf-2"
})(["display:flex;background:", ";"], function (props) {
  return (0, _utils.getThemeColor)(props, props.customColor);
});

exports.TabsPanelWrapper = TabsPanelWrapper;

var getActiveTabHeight = function getActiveTabHeight(props) {
  return "100%";
  /**
   * Idea was to assign height as much as active tab but during drag tab
   * height has extra 2px which causing recursive increase of OverflowWrapper's height.
   * Have to find work-around for this.
   */

  return props.activeTabRef.current ? "".concat(props.activeTabRef.current.getBoundingClientRect().height, "px") : "100%";
};

var OverflowWrapper =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "styles__OverflowWrapper",
  componentId: "sc-53bvbf-3"
})(["height:", ";overflow:hidden;position:relative;display:flex;"], function (props) {
  return getActiveTabHeight(props);
});

exports.OverflowWrapper = OverflowWrapper;

var BlurElement =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "styles__BlurElement",
  componentId: "sc-53bvbf-4"
})(["width:80px;height:100%;position:absolute;background:linear-gradient( to ", ",", "FF,", "00 );z-index:100;visibility:", ";pointer-events:none;"], function (props) {
  return props.dir === "left" ? "right" : "left";
}, function (props) {
  return (0, _utils.getThemeColor)(props, props.customColor);
}, function (props) {
  return (0, _utils.getThemeColor)(props, props.customColor);
}, function (props) {
  return props.visible ? "visible" : "hidden";
});

exports.BlurElement = BlurElement;

var IconWrapper =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "styles__IconWrapper",
  componentId: "sc-53bvbf-5"
})(["display:flex;justify-content:center;align-items:center;transition:visibility 250ms ease,width 150ms linear;visibility:", ";width:", ";cursor:pointer;z-index:100;:hover,:focus,:active{background:", ";}"], function (props) {
  return props.visible ? "visible" : "hidden";
}, function (props) {
  return props.visible ? "30px" : "0";
}, function (props) {
  return (0, _utils.getColorOfLightness)(props, props.customColor, 90);
});

exports.IconWrapper = IconWrapper;

var highlightBorderStyle = function highlightBorderStyle(props) {
  var customColor = props.customColor,
      active = props.active;
  var borderColor = active ? (0, _utils.getColorOfLightness)(props, customColor, 75) : "transparent";
  return "2px solid ".concat(borderColor);
};

var highlightBgColor = function highlightBgColor(props) {
  var customColor = props.customColor,
      active = props.active;
  var borderColor = active ? "#ffffff" : (0, _utils.getColorOfLightness)(props, customColor, 90);
  return borderColor;
};

var TabPanel =
/*#__PURE__*/
_styledComponents.default.button.withConfig({
  displayName: "styles__TabPanel",
  componentId: "sc-53bvbf-6"
})(["display:flex;flex-wrap:nowrap;justify-content:center;align-items:center;word-wrap:none;background:", ";color:", ";border:2px solid transparent;border-top:", ";padding:4px 14px;border-radius:4px 4px 0px 0px;min-width:80px;line-height:20px;font-size:14px;cursor:", ";margin-right:", ";:hover{background:", ";}:active,:focus{z-index:101 !important;outline-color:", ";border-color:", " auto 1px;}"], function (props) {
  return props.active ? (0, _utils.getThemeColor)(props, "Neutral0") : "none";
}, function (props) {
  return props.active ? (0, _utils.getThemeColor)(props, "Neutral90") : (0, _utils.getThemeColor)(props, "Neutral50");
}, function (props) {
  return highlightBorderStyle(props);
}, function (props) {
  return props.dragHandle && props.active ? "auto" : "pointer";
}, function (props) {
  return props.active ? "0" : "1px";
}, function (props) {
  return highlightBgColor(props);
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Azure80");
}, function (props) {
  return (0, _utils.getThemeColor)(props, "Azure80");
});

exports.TabPanel = TabPanel;

var TabContentWrapper =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "styles__TabContentWrapper",
  componentId: "sc-53bvbf-7"
})(["width:100%;"]);

exports.TabContentWrapper = TabContentWrapper;

var OverflowContainer =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "styles__OverflowContainer",
  componentId: "sc-53bvbf-8"
})(["display:flex;align-items:center;white-space:nowrap;width:100%;overflow-x:scroll;overflow-y:hidden;box-sizing:content-box;::-webkit-scrollbar{width:0px;background:transparent;display:none;}::-webkit-scrollbar-thumb{background:#ccc;}scrollbar-width:none;-ms-overflow-style:none;"]);

exports.OverflowContainer = OverflowContainer;
var DragIcon =
/*#__PURE__*/
(0, _styledComponents.default)(_.Icon).withConfig({
  displayName: "styles__DragIcon",
  componentId: "sc-53bvbf-9"
})(["cursor:grab;& svg{fill:", ";}margin-right:0.4rem;& svg:hover,& svg:active,& svg:focus{fill:#000000;}"], function (props) {
  return (0, _utils.getThemeColor)(props, "Neutral45");
});
exports.DragIcon = DragIcon;

var VerticalBar =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "styles__VerticalBar",
  componentId: "sc-53bvbf-10"
})(["height:14px;width:0px;position:absolute;border-right:1px solid #cccccc;top:50%;right:0;transform:translateY(-50%);pointer-events:none;"]);

exports.VerticalBar = VerticalBar;