"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTabContainerStyle = exports.DEFAULT_COLOR = exports.getWidthFromRef = void 0;

var getWidthFromRef = function getWidthFromRef(refNode) {
  return refNode.current ? refNode.current.offsetWidth : 0;
};

exports.getWidthFromRef = getWidthFromRef;
var DEFAULT_COLOR = "Beige10";
exports.DEFAULT_COLOR = DEFAULT_COLOR;

var getTabContainerStyle = function getTabContainerStyle(activeTabFlags, activeKeyIndex, itemIndex, itemRef) {
  var styles = "z-index: 99; position: relative;";

  if (activeKeyIndex === itemIndex) {
    styles = "z-index: 101";
  }

  if (activeTabFlags.left && activeKeyIndex === itemIndex) {
    styles = "\n      position: sticky;\n      position: -webkit-sticky;\n      z-index: 101;\n      left: 0;\n    ";
  } else if (activeTabFlags.right && activeKeyIndex === itemIndex) {
    styles = "\n      position: sticky;\n      position: -webkit-sticky;\n      z-index: 101;\n      right: 0;\n    ";
  }

  return styles;
};

exports.getTabContainerStyle = getTabContainerStyle;