/// <reference types="react" />
/// <reference types="styled-components/cssprop" />
import { ThemedStyledFunction } from "styled-components";
import { ColorPreset, CustomColor } from "../types";
export declare const insertIf: (obj: any, condition: boolean, isArray?: boolean) => any;
export declare function withProps<U>(): <P extends "symbol" | "object" | "a" | "abbr" | "address" | "area" | "article" | "aside" | "audio" | "b" | "base" | "bdi" | "bdo" | "big" | "blockquote" | "body" | "br" | "button" | "canvas" | "caption" | "cite" | "code" | "col" | "colgroup" | "data" | "datalist" | "dd" | "del" | "details" | "dfn" | "dialog" | "div" | "dl" | "dt" | "em" | "embed" | "fieldset" | "figcaption" | "figure" | "footer" | "form" | "h1" | "h2" | "h3" | "h4" | "h5" | "h6" | "head" | "header" | "hgroup" | "hr" | "html" | "i" | "iframe" | "img" | "input" | "ins" | "kbd" | "keygen" | "label" | "legend" | "li" | "link" | "main" | "map" | "mark" | "menu" | "menuitem" | "meta" | "meter" | "nav" | "noindex" | "noscript" | "ol" | "optgroup" | "option" | "output" | "p" | "param" | "picture" | "pre" | "progress" | "q" | "rp" | "rt" | "ruby" | "s" | "samp" | "script" | "section" | "select" | "small" | "source" | "span" | "strong" | "style" | "sub" | "summary" | "sup" | "table" | "tbody" | "td" | "textarea" | "tfoot" | "th" | "thead" | "time" | "title" | "tr" | "track" | "u" | "ul" | "var" | "video" | "wbr" | "webview" | "svg" | "animate" | "animateMotion" | "animateTransform" | "circle" | "clipPath" | "defs" | "desc" | "ellipse" | "feBlend" | "feColorMatrix" | "feComponentTransfer" | "feComposite" | "feConvolveMatrix" | "feDiffuseLighting" | "feDisplacementMap" | "feDistantLight" | "feDropShadow" | "feFlood" | "feFuncA" | "feFuncB" | "feFuncG" | "feFuncR" | "feGaussianBlur" | "feImage" | "feMerge" | "feMergeNode" | "feMorphology" | "feOffset" | "fePointLight" | "feSpecularLighting" | "feSpotLight" | "feTile" | "feTurbulence" | "filter" | "foreignObject" | "g" | "image" | "line" | "linearGradient" | "marker" | "mask" | "metadata" | "mpath" | "path" | "pattern" | "polygon" | "polyline" | "radialGradient" | "rect" | "stop" | "switch" | "text" | "textPath" | "tspan" | "use" | "view" | import("react").ComponentClass<any, any> | import("react").FunctionComponent<any>, T extends object, O extends object = {}>(fn: ThemedStyledFunction<P, T, O, never>) => ThemedStyledFunction<P & U, T, O & U, never>;
/**
 * Used for parsing hsl color values defined in [h, s, l] format
 * into a chroma object
 */
export declare const hslToChroma: (hsl: number[]) => any;
/**
 * Checks if the color is light or darks based on its L value in
 * the HSL color scale.
 * @param color A chroma color instance
 */
export declare const isLightColor: (color: any) => boolean;
/**
 * Returns font color of updated lightness on hover
 * @param color A chroma color instance
 */
export declare const getHoverFontColor: (color: any) => any;
/**
 * Returns background color of updated lightness on hover
 * @param color A chroma color instance
 */
export declare const getHoverBackgroundColor: (color: any) => any;
/**
 * Determines the appropriate font color based on the background color.
 */
export declare const getFontColor: (theme: any, backGroundColor: any) => any;
/**
 * Creates an object with background and font properties initialized
 * with appropriate chroma colors.
 * @param backGroundColor A plain CSS color string
 */
export declare const parseCustomColor: (theme: any, customColor: CustomColor) => {
    background: any;
    font: any;
};
/**
 * Creates an object with background and font properties initialized
 * with appropriate chroma colors.
 * @param backGroundColor One of the predefined preset values
 */
export declare const parseColorPreset: (theme: any, backgroundColor: ColorPreset) => {
    background: any;
    font: any;
};
/**
 * Get color from Styled Component Props
 */
export declare const getThemeColor: (props: any, color: string) => any;
/**
 * Get different lightness of passed color, range of lightness is between 0 to 100
 */
export declare const getColorOfLightness: (props: any, color: string, lightness: number) => any;
/**
 * Get font-size from Styled Component Props
 */
export declare const getThemeFontSize: (props: any, size: number) => any;
/**
 * Get line-height from Styled Component Props
 */
export declare const getThemeLineHeight: (props: any, size: number) => any;
/**
 * Get OS of current platform
 */
export declare const getOSName: () => string | undefined;
