import { ReactNode, Component } from "react";
export declare type sizeType = "x-small" | "small" | "medium" | "large";
export declare type alertType = "neutral" | "warning" | "success" | "danger" | "unsaved";
export declare type placementType = "topLeft" | "topRight" | "bottomLeft" | "bottomRight";
export declare type actionType = {
    text: string;
    callback: Function;
};
export interface AlertProps {
    type?: alertType;
    size?: sizeType;
    content: ReactNode;
    autoDismiss?: boolean;
    dismissDuration?: number;
    heading?: string;
    icon?: string;
    image?: string;
    multiLine?: boolean;
    actions?: Array<actionType>;
    onClose?: (event: any) => void;
    onExit?: (key: string) => void;
    placement?: placementType;
    alertKey?: string;
    className?: string;
    prefixClassName?: string;
    customColor?: string;
}
export declare type addAlertType = (props: AlertProps) => string;
export declare type removeAlertType = (key: string) => boolean;
export interface AlertContextInterface {
    addAlert: addAlertType;
    removeAlert: removeAlertType;
}
export interface AlertsProviderState {
    alerts: AlertProps[];
    contextAPI: AlertContextInterface;
}
export declare type AlertProviderType = Component<{}, AlertsProviderState>;
export declare type useAlertType = () => {
    addAlert: addAlertType;
    removeAlert: removeAlertType;
};
